package fr.llibre.ml2;

public final class Astro {
	/**
	 * Constructeur bidon.
	 */
	private Astro() {}	

	public static final String nomPla[]= {"Mercure", "Vénus", "Terre", "Mars", "Jupiter",
		"Saturne", "Uranus", "Neptune"};
	
	/* Liste des constellations en correspondance :
	 * 	- Abrév. std. 3 lettres : tableau Constels3[]
	 *  - Nom français :  	tableau nomConstelsFr[]
	 *  - Nom latin :     	tableau nomConstelsLatinN[]
	 *  - Genitif Latin : 	tableau nomConstelsLatinG[]
	 *  L'accès à ces tableaux se fait par l'index ixCons qui normalement varie de 0
	 *  à Constels3.length-1. Mais comme la méthode cons3toIndex() renvoie la valeur
	 *  Constels3.length quand l'abréviation argument n'est pas reconnue, un string vide
	 *  est ajouté en fin des noms français et latins pour traiter ce cas.
	 */
			
	public static final String Constels3[] =
		{"And", "Ant", "Aps", "Aql", "Aqr", "Ara", "Ari", "Aur", "Boo", "Cae", "Cam", "Cap",
		"Car", "Cas", "Cen", "Cep", "Cet", "Cha", "Cir", "CMa", "CMi", "Cnc", "Col", "Com",
		"CrA", "CrB", "Crt", "Cru", "Crv", "Cvn", "Cyg", "Del", "Dor", "Dra", "Equ", "Eri",
		"For", "Gem", "Gru", "Her", "Hor", "HyA", "HyI", "Ind", "Lac", "Leo", "Lep", "Lib",
		"LMi", "Lup", "Lyn", "Lyr", "Men", "Mic", "Mon", "Mus", "Nor", "Oct", "Oph", "Ori",
		"Pav", "Peg", "Per", "Phe", "Pic", "PsA", "Psc", "Pup", "Pyx", "Ret", "Scl", "Sco",
		"Sct", "Ser", "Sex", "Sge", "Sgr", "Tau", "Tel", "TrA", "Tri", "Tuc", "UMa", "UMi",
		"Vel", "Vir", "Vol", "Vul"}; 
	
	public static final String nomConstelsFrLong[] =
		{"Andromède", "La Machine pneumatique", "L’Oiseau de paradis", "L’Aigle", "Le Verseau", "L’Autel",
		"Le Bélier", "Le Cocher", "Le Bouvier", "Le Burin", "La Girafe", "Le Capricorne", "La Carène",
		"Cassiopée", "Le Centaure", "Céphée", "La Baleine", "Le Caméléon", "Le Compas", "Le Grand Chien",
		"Le Petit Chien", "Le Cancer", "La Colombe", "La Chevelure de Bérénice", "La Couronne australe",
		"La Couronne boréale", "La Coupe, le Cratère", "La Croix du Sud", "Le Corbeau", "Les Chiens de chasse",
		"Le Cygne", "Le Dauphin", "La Dorade", "Le Dragon", "Le Petit Cheval", "L’Éridan", "Le Fourneau",
		"Les Gémeaux", "La Grue", "Hercule", "L’Horloge", "L’Hydre", "L’Hydre mâle", "L’Indien", "Le Lézard",
		"Le Lion", "Le Lièvre", "La Balance", "Le Petit Lion", "Le Loup", "Le Lynx", "La Lyre", "La Table",
		"Le Microscope", "La Licorne", "La Mouche", "La Règle", "L’Octant", "Ophiuchus, Serpentaire", "Orion",
		"Le Paon", "Pégase", "Persée", "Le Phénix", "Le Peintre", "Le Poisson austral", "Les Poissons",
		"La Poupe", "La Boussole", "Le Réticule", "Le Sculpteur", "Le Scorpion", "L’Écu de Sobieski",
		"Le Serpent", "Le Sextant", "La Flèche", "Le Sagittaire", "Le Taureau", "Le Télescope",
		"Le Triangle austral", "Le Triangle", "Le Toucan", "La Grande Ourse", "La Petite Ourse", "Les Voiles",
		"La Vierge", "Le Poisson volant", "Le Petit Renard", ""};	
	
	public static final String nomConstelsFrCourt[] =
		{"Andromède", "Machine pneumatique", "Oiseau de paradis", "Aigle", "Verseau", "Autel",
		"Bélier", "Cocher", "Bouvier", "Burin", "Girafe", "Capricorne", "Carène",
		"Cassiopée", "Centaure", "Céphée", "Baleine", "Caméléon", "Compas", "Grand Chien",
		"Petit Chien", "Cancer", "Colombe", "Chevelure de Bérénice", "Couronne australe",
		"Couronne boréale", "Coupe/Cratère", "Croix du Sud", "Corbeau", "Chiens de chasse",
		"Cygne", "Dauphin", "Dorade", "Dragon", "Petit Cheval", "Éridan", "Fourneau",
		"Gémeaux", "Grue", "Hercule", "Horloge", "Hydre", "Hydre mâle", "Indien", "Lézard",
		"Lion", "Lièvre", "Balance", "Petit Lion", "Loup", "Lynx", "Lyre", "Table",
		"Microscope", "Licorne", "Mouche", "Règle", "Octant", "Ophiuchus/Serpentaire", "Orion",
		"Paon", "Pégase", "Persée", "Phénix", "Peintre", "Poisson austral", "Poissons",
		"Poupe", "Boussole", "Réticule", "Sculpteur", "Scorpion", "Écu de Sobieski",
		"Serpent", "Sextant", "Flèche", "Sagittaire", "Taureau", "Télescope",
		"Triangle austral", "Triangle", "Toucan", "Grande Ourse", "Petite Ourse", "Voiles",
		"Vierge", "Poisson volant", "Petit Renard", ""};	
	
	public static final String nomConstelsLatinN[] =
		{"Andromeda", "Antlia", "Apus", "Aquila", "Aquarius", "Ara", "Aries", "Auriga",
		"Bootes", "Caelum", "Camelopardalis", "Capricornus", "Carina", "Cassiopeia",
		"Centaurus", "Cepheus", "Cetus", "Chamaeleon", "Circinus", "Canis Major",
		"Canis Minor", "Cancer", "Columba", "Coma Berenices", "Corona Australis",
		"Corona Borealis", "Crater", "Crux", "Corvus", "Canes Venatici", "Cygnus",
		"Delphinus", "Dorado", "Draco", "Equuleus", "Eridanus", "Fornax", "Gemini",
		"Grus", "Hercules", "Horologium", "Hydra", "Hydrus", "Indus", "Lacerta", "Leo",
		"Lepus", "Libra", "Leo Minor", "Lupus", "Lynx", "Lyra", "Mensa", "Microscopium",
		"Monoceros", "Musca", "Norma", "Octans", "Ophiuchus", "Orion", "Pavo", "Pegasus",
		"Perseus", "Phoenix", "Pictor", "Piscis Austrinus", "Pisces", "Puppis", "Pyxis",
		"Reticulum", "Sculptor", "Scorpius", "Scutum", "Serpens", "Sextans", "Sagitta",
		"Sagittarius", "Taurus", "Telescopium", "Triangulum Australe", "Triangulum",
		"Tucana", "Ursa Major", "Ursa Minor", "Vela", "Virgo", "Volans", "Vulpecula", ""};	
	
	public static final String nomConstelsLatinG[] =
		{"Andromedae", "Antliae", "Apodis", "Aquilae", "Aquarii", "Arae", "Arietis", "Aurigae",
		"Bootis", "Caeli", "Camelopardalis", "Capricorni", "Carinae", "Cassiopeiae",
		"Centauri", "Cephei", "Ceti", "Chamaeleontis", "Circini", "Canis Majoris",
		"Canis Minoris", "Cancri", "Columbae", "Comae Berenices", "Coronae Australis",
		"Coronae Borealis", "Crateris", "Crucis", "Corvi", "Canum Venaticorum", "Cygni",
		"Delphini", "Doradus", "Draconis", "Equulei", "Eridani", "Fornacis", "Geminorum",
		"Grusis", "Herculis", "Horologii", "Hydrae", "Hydri", "Indi", "Lacertae", "Leonis",
		"Leporis", "Librae", "Leonis Minoris", "Lupi", "Lyncis", "Lyrae", "Mensae", "Microscopii",
		"Monocerotis", "Muscae", "Normae", "Octantis", "Ophiuchi", "Orionis", "Pavonis", "Pegasi",
		"Persei", "Phoenicis", "Pictoris", "Piscis Austrini", "Piscium", "Puppis", "Pyxidis",
		"Reticuli", "Sculptoris", "Scorpii", "Scuti", "Serpentis", "Sextantis", "Sagittae",
		"Sagittarii", "Tauri", "Telescopii", "Trianguli Australis", "Trianguli",
		"Tucanae", "Ursae Majoris", "Ursae Minoris", "Velorum", "Virginis", "Volantis", "Vulpeculae", ""};	

	public static final double constelAD_rd[] = {
		0.2114, 2.6897, 4.2265, 5.1488, 5.8354, 4.5487, 0.6901, 1.5901, 3.8512,
		1.2316, 2.3185, 5.5106, 2.2763, 0.3454, 3.4220, 5.7596, 0.4368, 2.7992,
		3.8159, 1.7878, 2.0035, 2.2644, 1.5348, 3.3478, 4.8816, 4.1477, 2.9834,
		3.2594, 3.2573, 3.4338, 5.3899, 5.4175, 1.3723, 3.9647, 5.5469, 0.8640,
		0.7325, 1.8511, 5.8791, 4.5516, 0.8577, 3.0401, 0.6137, 5.7523, 5.8804,
		2.7927, 1.4571, 3.9792, 2.6822, 3.9846, 2.0923, 4.9357, 1.4176, 5.4885,
		1.8484, 3.2955, 4.1634, 6.0214, 4.5540, 1.4599, 5.1344, 5.9421, 0.8312,
		0.2440, 1.4943, 5.8341, 0.1264, 1.9001, 2.3438, 1.0266, 0.1147, 4.4211,
		4.8886, 4.4377, 2.6891, 5.1446, 5.0001, 1.2310, 6.2249, 5.0594, 4.2104,
		0.5719, 2.9616, 3.9270, 2.5073, 3.5098, 2.0409, 5.2966};	
	
	public static final double constelDec_rd[] = {
		0.6533, -0.5669, -1.3142, 0.0595, -0.1883, -0.9877, 0.3629, 0.7335, 0.5446,
		-0.6612, 1.2109, -0.3146, -1.1034, 1.0853, -0.8263, 1.2393, -0.1253, -1.3824,
		-1.1001, -0.3864, 0.1122, 0.3457, -0.6125, 0.4068, -0.7182, 0.5694, -0.2780,
		-1.0505, -0.3218, 0.6999, 0.7775, 0.2037, -1.0365, 1.1695, 0.1354, -0.5019,
		-0.5521, 0.3944, -0.8090, 0.4799, -0.9309, -0.2536, -1.2210, -1.0421, 0.8036,
		0.2293, -0.3324, -0.2659, 0.5609, -0.7454, 0.8284, 0.6403, -1.3527, -0.6331,
		0.0049, -1.2245, -0.8963, -1.4338, -0.1381, 0.1038, -1.1481, 0.3398, 0.7856,
		-0.8479, -0.9333, -0.5348, 0.2389, -0.5441, -0.4774, -1.0472, -0.5600, -0.4718,
		-0.1726, 0.1068, -0.0456, 0.3292, -0.4970, 0.2597, -1.1490, -0.8908, 0.5653,
		0.5494, 0.8853, 1.3561, -0.8232, -0.0726, -1.2183, 0.4266};	

	/* Renvoi l'index du nom abrégé de 3 lettres dans sa liste, ou Constels3.length si pas trouvé, car il
	    pointe sur un string vide dans les autres listes */
	public static int cons3toIndex(String c3)
	{
		for (int k = 0; k < Constels3.length; k++)
		{
			if (c3.equalsIgnoreCase(Constels3[k])) return k;
		}
		return Constels3.length;
	}
	
	/* Renvoi le nom français correspondant au nom abrégé de 3 lettres */ 
	public static String cons3toFrCourt(String c3)
	{
		for (int k = 0; k < Constels3.length; k++)
		{
			if (c3.equalsIgnoreCase(Constels3[k])) return nomConstelsFrCourt[k];
		}
		return "";
	}
	
	/* Renvoi le nom français correspondant au nom abrégé de 3 lettres */ 
	public static String cons3toFrLong(String c3)
	{
		for (int k = 0; k < Constels3.length; k++)
		{
			if (c3.equalsIgnoreCase(Constels3[k])) return nomConstelsFrLong[k];
		}
		return "";
	}
	
	/* Renvoi le nom latin correspondant au nom abrégé de 3 lettres */ 
	public static String cons3toLatinN(String c3)
	{
		for (int k = 0; k < Constels3.length; k++)
		{
			if (c3.equalsIgnoreCase(Constels3[k])) return nomConstelsLatinN[k];
		}
		return "";
	}
	
	/* Renvoi le génitif latin correspondant au nom abrégé de 3 lettres */ 
	public static String cons3toLatinG(String c3)
	{
		for (int k = 0; k < Constels3.length; k++)
		{
			if (c3.equalsIgnoreCase(Constels3[k])) return nomConstelsLatinN[k];
		}
		return "";
	}

	/* Distance approximative en cordonnées polaires uniquement dans un but de classement 
	 *                 Toutes les valeurs sont en RADIANS
	 * */
	public static double distCorPol_rd(double AD1, double Dec1, double AD2, double Dec2)
	{
		double dB = Dec1 - Dec2;
		double bM = (Dec1 + Dec1)/2.;
		double dA = (AD1 - AD2)* Math.cos(bM);
		return Math.hypot(dA, dB);
	}

	/* 
	 * Paramètres astronomiques à variation lente.
	 * Ces paramètres ne sont à recalculer que si le temps écoulé est supérieur
	 * à une certaine valeur, par exemple tous les jours.
	 * Certaines routines ont un argument booleen nommé "eco". S'il vaut "true"
	 * ces paramètres à variation lente ne sont pas calculés. On utilise la valeur
	 * mémorisée. S'il vaut "false", il sont calculés, pour une utilisation locale,
	 * mais non mémorisés. De même, certaines routines sont en double, une avec
	 * un suffixe _eco et l'autre avec un suffixe _std. Celle avec un suffixe _eco
	 * utilse les paramètres mémorisés et celle avec le suffixe _std calcule ses
	 * propres paramètres, sans les mémoriser. 
	 * La routine update_eco(double ju) permet d'actualiser ces paramètres à la
	 * date ju.
	 * Il est de la responsabilité du programmeur qui utilise une routine avec
	 * -----------------------------------------------------------------------
	 * l'argument "eco" à true de vérifier avant d'appeler cette routine que juIni
	 * ---------------------------------------------------------------------------
	 * est séparé de ju de moins d'un jour.
	 * -----------------------------------
	 * Par contre il peut appeler les routine avec le suffixe _eco sans vérifier,
	 * car cette vérification est faite dans la routine, avec appel éventuel de
	 * update_eco(double ju), si nécessaire.
	 */
	public static boolean synchroOk = false; // parametres non initialisés
	public static double juIni = 2451545.; // Date d'initialisation des paramètres
	public static double jeIni = juIni + Utils.jul2deltaT(juIni);
	public static double  deltaT = 0; 		
	public static double ctetChg = 1.;		// Cos Eta Chgment Equa.
	public static double stetChg = 0.;		// Sin Eta Chgment Equa.
	public static double zetaChg_dg = 0.;	// Zeta Chgment Equa.
	public static double zetaChg_rd = 0.;
	public static double zedeChg_dg = 0.;	// Zede Chgment Equa.
	public static double zedeChg_rd = 0.;
	public static double dpsi_dg = 0.;		// Delta Psi Nutation	
	public static double dpsi_rd = 0.;
	public static double dobli_dg = 0.;		// Delta Obli Nutation 	
	public static double dobli_rd = 0.;
	public static double obli_dg = 23.4392911;	// Obliquité
	public static double obli_rd = Math.toRadians(obli_dg);
	public static double cosEps = Math.cos(obli_rd);
	public static double sinEps = Math.sin(obli_rd);
    /** Matrice passage Re -> RcVrai */
    public static double m3_CvE[][] = {{1.,0.,0.}, {0., cosEps, -sinEps},
            {0. , sinEps, cosEps}};
    /** Matrice passage Rcv -> Rcm */
    public static double m3_CCvm[][] = {{1.,0.,0.},{0.,1.,0.},{0.,0.,1.}};
    public static double deltaTsg_dg = dpsi_dg*cosEps;
	public static double deltaTsg_rd = dpsi_rd*cosEps;
	public static double excenT = 0.016708634;
	public static double lonSolV_dg = 280.382158; // longitude soleil vrai
	public static double lonSolV_rd = Math.toRadians(lonSolV_dg);
	public static double cosLES = Math.cos(lonSolV_rd);
	public static double sinLES = Math.sin(lonSolV_rd);
	public static double lonPeriT_dg = 102.93735; // longitude périhélie de la Terre
	public static double lonPeriT_rd = Math.toRadians(lonPeriT_dg);
	public static double cosLPT = Math.cos(lonPeriT_rd);
	public static double sinLPT = Math.sin(lonPeriT_rd);

    public static final double raySol = 696342.0e03;
    public static final double UA = 149597870691.; // U.A en mètres

    public static double m3_A[][] = {{1.,0.,0.},{0.,1.,0.},{0.,0.,1.}};
    public static double m3_B[][] = {{1.,0.,0.},{0.,1.,0.},{0.,0.,1.}};
    public static double m3_C[][] = {{1.,0.,0.},{0.,1.,0.},{0.,0.,1.}};
    public static double m3_CCd0[][] = {{1.,0.,0.},{0.,1.,0.},{0.,0.,1.}};
    public static double m3_CCv0[][] = {{1.,0.,0.},{0.,1.,0.},{0.,0.,1.}};


    /** Mise a jour des parametres astro variant lentement en fonction du temps
	 *  (deltaT, obliquite, etc...). Voir explications ci-dessus avant la liste
	 * des paramètres.
     *  	 
	 * @param ju : date julienne temps UT de calcul des parametres.
	 * @author Michel Llibre.
	 */
	public static void update_eco(double ju)
	{
		if (ju == juIni) return; // déjà fait
		deltaT = Utils.jul2deltaT(ju);
		double je = ju + deltaT;
		double T = (je - 2451545)/365.25; // année julienne
		double S = T/100.; // siecle julien
		zetaChg_dg = S*(2306.2181+S*(0.30188+S*0.017998))/3600.;
		zetaChg_rd = Math.toRadians(zetaChg_dg);
		zedeChg_dg = S*(2306.2181+S*(1.09468+S*0.018203))/3600.;
		zedeChg_rd = Math.toRadians(zedeChg_dg);
		double tetaChg_rd = Math.toRadians(S*(2004.3109+S*(-0.42665-S*0.041883))/3600.);
		ctetChg = Math.cos(tetaChg_rd);
		stetChg = Math.sin(tetaChg_rd);
		double tdeps [] = {0};
		dpsi_rd = nutationEcli_rd(je, true, tdeps);	
		dpsi_dg = Math.toDegrees(dpsi_rd);
		dobli_rd = tdeps [0];
		dobli_dg = Math.toDegrees(dobli_rd);
		obli_dg = obliquity_dg(je) + dobli_dg;
		obli_rd = Math.toRadians(obli_dg);
		cosEps = Math.cos(obli_rd);
		sinEps = Math.sin(obli_rd);
		deltaTsg_dg = dpsi_dg*cosEps; 
		deltaTsg_rd = dpsi_rd*cosEps; 
		excenT = eccentricity(S);
		lonSolV_dg = sun_longi_dg(S);
		lonSolV_rd = Math.toRadians(lonSolV_dg);
		cosLES = Math.cos(lonSolV_rd);
		sinLES = Math.sin(lonSolV_rd);
		lonPeriT_dg = earth_longiPerih_dg(S);
		lonPeriT_rd = Math.toRadians(lonPeriT_dg);
		cosLPT = Math.cos(lonPeriT_rd);
		sinLPT = Math.sin(lonPeriT_rd);

		updateMat();
        // C'est fini
		juIni = ju;
		synchroOk = true;
	}

    /** Mise à jour des matrices astro variant lentement en fonction du temps
     *  Suppose que update_eco(ju) a été préalablement appelé.
     * @author Michel Llibre.
     */
    private static void updateMat()
    {
        // Mise à jour Equatorial J2000 vers Equatorial de la date
        double c = Math.cos(zedeChg_rd), s = Math.sin(zedeChg_rd);
        m3_A[0][0] = c; m3_A[0][1] = -s;
        m3_A[1][0] = s; m3_A[1][1] = c;
        c = ctetChg; s = stetChg;
        m3_B[0][0] = c; m3_B[0][2] = -s;
        m3_B[2][0] = s; m3_B[2][2] = c;
        c = Math.cos(zetaChg_rd); s = Math.sin(zetaChg_rd);
        m3_C[0][0] = c; m3_C[0][1] = -s;
        m3_C[1][0] = s; m3_C[1][1] = c;
        R3.madmad(m3_CCd0, m3_B, m3_C);
        R3.madmad(m3_CCd0, m3_CCd0, m3_A);
        // mise a jour matrice passage celeste moyen de la date -> celeste vrai de la date
        m3_CCvm[1][0] = dpsi_rd*cosEps;
        m3_CCvm[2][0] = dpsi_rd*sinEps;
        m3_CCvm[0][1] = -m3_CCvm[1][0];
        m3_CCvm[0][2] = -m3_CCvm[2][0];
        m3_CCvm[2][1] = dobli_rd;
        m3_CCvm[1][2] = -dobli_rd;
        // maj passage celeste JO -> celsete vrai de la date
        R3.madmad(m3_CCv0, m3_CCvm, m3_CCd0);
		// mise a jour matrice passage écliptique moyen de la date -> céleste vrai de la date en cas de besoin externe
		m3_CvE[0][0] = 1.;
		m3_CvE[1][1] =  m3_CvE[2][2] = cosEps;
		m3_CvE[2][1] = sinEps;
		m3_CvE[1][2] = -sinEps;
		m3_CvE[1][0] = m3_CvE[0][1] = m3_CvE[2][0] = m3_CvE[0][2] = 0.;
		R3.madmad(m3_CvE, m3_CCvm, m3_CvE);
    }


	/**
	 * Renvoie l'angle "polaris in Scope" et l'angle horaire de la polaire
	 * (dans HA_dg[0]) le tout en degrés.	 
	 * @param ju       : date julienne temps UT de calcul.
	 * @param longi_dg : longitude (degres) du lieu d'observation
	 * @param HA_dg    : Angle horaire de la polaire (in/out)
	 * @param eco      : True si utilisations paramètres variant lentement
	 * @return         : valeur "polaris in scope" en degres.
	 */
	public static double polarisInScope_dg(double ju, double longi_dg, double HA_dg[], boolean eco)
	{
//	double ad0_rd = 0.6624033565683644;
		double ad0_rd = 0.662432049781267; // SIMBAD
//	double de0_rd = 1.557953612382305;
		double de0_rd = 1.55795260542429; // SIMBAD
//		double vA_rda = 1.434543020400889E-5;
		double vA_rda = 1.67903871545216e-005; // SIMBAD
//		double vD_rda = -7.272205216643039E-8;
		double vD_rda = -5.74504212114800E-8; // SIMBAD
		double t = (ju - 2451545)/365.25;
		double adt_rd = ad0_rd + vA_rda*t;
		double det_rd = de0_rd + vD_rda*t;						
		double tde_dg[] = {0};
		double alfa_rd;
		if (eco) alfa_rd =  equaJ0toApp_rd_eco (ju, adt_rd, det_rd, tde_dg);
		else alfa_rd =  equaJ0toApp_rd_std (ju, adt_rd, det_rd, tde_dg);
		//		double decli_rd = tde_dg[0];
		double alfa_dg = Math.toDegrees(alfa_rd);
		//		double decli_dg = Math.toDegrees(decli_rd);
		double hourAng_dg = jul2alst_dg(ju, longi_dg, eco) - alfa_dg;	
		HA_dg[0] = hourAng_dg;
		double pol2 = (180. - hourAng_dg)%360.;
		if (pol2 < 0) pol2 += 360;
		return pol2/2.;	
	}

	/**
	 *      Variation de hauteur astre due a la refaction
	 * @param h      : hauteur theorique ou apparente en degres
	 * @param th2ap  : true si h_dg est theorique, false si apparente (observee)
	 * @param tc     : temperature en Celsius
	 * @param pm     : pression en millibar
	 * @return       : dh_dg variation de hauteur en degres
	 */
	public static double refraction_dg(double h, boolean th2ap, double tc, double pm)
	{
		double arg, dh_dg;
		double K = (283./(tc+273.))*pm/1010.;
		if (th2ap)
		{
			arg = h + 10.3/(h + 5.1);
			if (arg < 90.)
			{
				arg = Math.toRadians(arg);
				dh_dg = K*(1.02/ Math.tan(arg))/60.;
			}
			else dh_dg = 0.;
		}
		else
		{
			arg = h + 7.31/(h + 4.4);
			if (arg < 90.)
			{
				arg = Math.toRadians(arg);
				dh_dg = K*(1./ Math.tan(arg))/60.;
			}
			else dh_dg = 0.;
		}
		return dh_dg;
	}

	/**
	 *      Variation de hauteur astre due a la refaction
	 * @param h      : hauteur theorique ou apparente en degres
	 * @param th2ap  : true si h_dg est theorique, false si apparente (observee)
	 * @return       : dh_dg variation de hauteur en degres
	 */	
	public static double refraction_dg(double h, boolean th2ap)
	{
		return refraction_dg(h, th2ap, 10., 1010.);
	}

	/**
	 *      Variation de hauteur astre due a la refaction
	 * @param h      : hauteur theorique en degres
	 * @return       : dh_dg variation de hauteur en degres
	 */	
	public static double refraction_dg(double h)
	{
		return refraction_dg(h, true, 10., 1010.);
	}

	/**
	 *      Calcul des corrections écliptiques de nutation (en radians)
	 * @param je    :  jour julien des éphémérides
	 * @param hyper : true pour calculs hyper-précis
	 * @param deps  : deps[0] = variation d'obliquite (en retour)
	 * @return      : dpsi = variation de longitude ecliptique
	 */
	public static  double nutationEcli_rd(double je, boolean hyper, double deps[])
	{
		double T =  (je-2451545)/36525;
		double torad = Math.PI/180.;
		double dpsi, dobi;
		if (hyper) 
		{
			double D  = 297.85036 + T*(445267.111480 + T*(-0.0019142 + T/189474));
			double M  = 357.52772 + T*(35999.050340 + T*(-0.0001603 - T/300000));
			double Mp = 134.96298 + T*(477198.867398 + T*(0.0086972 + T/56250));
			double F  =  93.27191 + T*(483202.017538 + T*(-0.0036825 + T/327270));
			double O  = 125.04452  +T*(-1934.136261 + T*(0.0020708  + T/450000));
			D *= torad;	M *= torad;	Mp *= torad;	F *= torad;	O *= torad;
			double Lp = F + O;	
			double L = Lp - D; 
			dpsi = -(171996+174.2*T)* Math.sin(O)-(13187+1.6*T)* Math.sin(2*L)-(2274+0.2*T)* Math.sin(2*Lp)
					+(2062+0.2*T)* Math.sin(2*O)+(1426-3.4*T)* Math.sin(M)+(712+0.1*T)* Math.sin(Mp)+(-517+1.2*T)* Math.sin(2*L+M)
					-(386+0.4*T)* Math.sin(Lp+F)-301* Math.sin(2*Lp+Mp)+(217-0.5*T)* Math.sin(2*L-M)-158* Math.sin(Mp-2*D)
					+(129+0.1*T)* Math.sin(2*L-O)+123* Math.sin(2*Lp-Mp)+63* Math.sin(2*D);
			dobi =  (92025+8.9*T)* Math.cos(O)+(5736-3.1*T)* Math.cos(2*L)+(977-0.5*T)* Math.cos(2*Lp)
					+(-895+0.5*T)* Math.cos(2*O)+(54-0.1*T)* Math.cos(M)-7* Math.cos(Mp)+(224-0.6*T)* Math.cos(2*L+M)
					+200* Math.cos(Lp+F)+(129-0.1*T)* Math.cos(2*Lp+Mp)+(-95+0.3*T)* Math.cos(2*L-M)-70* Math.cos(2*L-O)-53* Math.cos(2*Lp-Mp);
			double fromdeg = 10000*3600.;
			dpsi = Math.toRadians(dpsi/fromdeg);
			dobi = Math.toRadians(dobi/fromdeg);
		}
		else
		{
			double O = 125.04452  - 1934.136261*T;
			double L = 280.4665 + 36000.7698*T;
			double Lp = 218.3165 + 481267.8813*T;
			O *= torad;	L *= torad;	Lp *= torad;
			double dL = 2.*L; 
			double dLp = 2.*Lp; 
			double dO = 2.*O;
			dpsi = -17.20* Math.sin(O) - 1.32* Math.sin(dL) - 0.23* Math.sin(dLp) + 0.21* Math.sin(dO);
			dobi =   9.20* Math.cos(O) + 0.57* Math.cos(dL) + 0.10* Math.cos(dLp) - 0.09* Math.cos(dO);
			dpsi = Math.toRadians(dpsi/3600.);
			dobi = Math.toRadians(dobi/3600.);
		}
		deps[0] = dobi;
		return dpsi;
	}	

	/**
	 *     Temps sideral moyen pour Greenwich (= ascension droite de Greenwich)
	 * @param ju : date en jour julien UT.
	 * @return   : le temps sideral moyen pour Greenwich en degrés
	 */
	public static double jul2mgst_dg(double ju)
	{
		double djj = ju - 2451545;
		double T = djj/36525.;
		double tsg_dg = 280.46061837 + 360.98564736629*djj + T*T*(0.000387933-T/38710000);
		tsg_dg = tsg_dg%360.;
		if (tsg_dg < 0.) tsg_dg += 360.;
		return tsg_dg;	
	}

	/**
	 *      Obliquite moyenne en degres
	 * @param je  : date en jour julien des éphémérides
	 * @return
	 */
	public static double obliquity_dg(double je)
	{
		double T =  (je-2451545)/36525.;
		double obliq = 23. + 26./60. + (21.448 - T*(46.8150 + T*(0.00059 - 0.001813*T)))/3600.;
		return obliq;
	}

	/**
	 *     Temps sideral apparent pour Greenwich (= ascension droite de Greenwich)
	 *   (le Temps sideral apparent est le temps sidéral moyen corrigé de la nutation)
	 * @param ju  : date en jour julien UT.
	 * @param eco : true pour utilisation des paramètres variant lentement
	 * @return  le temps sideral apparent pour Greenwich en degrés
	 */
	public static double jul2agst_dg(double ju, boolean eco)
	{
		double tsg_dg = jul2mgst_dg(ju);
		if (eco) tsg_dg += deltaTsg_dg;
		else
		{	
			double je = ju + Utils.jul2deltaT(ju);
			double tdeps [] = {0};
			double dpsi_rd = nutationEcli_rd(je, true, tdeps);
			double eps_rd = Math.toRadians(obliquity_dg(je)) + tdeps[0];
			tsg_dg += Math.toDegrees(dpsi_rd* Math.cos(eps_rd));
		}
		tsg_dg = tsg_dg%360.;
		if (tsg_dg < 0.) tsg_dg += 360.;		
		return tsg_dg;	
	}

	/**
	 *    Temps sideral apparent local d'un lieu situé à la longitude "longi"
	 *      (c'est egalement l'ascension droite du meridien a cette date.)
	 * @param ju    : date en jour julien UT.
	 * @param longi : longitude du lieu en DEGRES
	 * @param eco   : true pour version utilisant les paramètres variant lentement
	 * @return      : le Temps sideral apparent local en DEGRES
	 */
	public static double jul2alst_dg(double ju, double longi, boolean eco)
	{
		return  jul2agst_dg(ju, eco) + longi;	
	}

	/*
	Longitude (en dg) du Soleil a la date T (courante par defaut)
	C'est la longitude geometrique du vrai soleil mesuree par rapport a
	l'equinoxe moyen de la date (precession prise en compte), et non a
	l'equinoxe vraie (nutation non prise en compte).
	Entree :
		siecle julien du calcul : S  = (je-2451545)/36525;
	Sorties :
		longSolV_dg  : longitude vraie (geometrique) du Soleil a la date S
	 */
	public static double sun_longi_dg(double S)
	{
		double L_dg = 280.46646 + S*(36000.76983 + S*0.0003032);
		L_dg = L_dg%360.;
		// Anomalie moyenne du Soleil/gamma de la date
		double M_dg = 357.52911 + S*(35999.05029 - S*0.0001537);
		M_dg = M_dg%360.;
		double M = Math.toRadians(M_dg);
		// Equation du centre (C = M - v)
		double C_dg = (1.914602 - S*(0.004817 + S*0.000014*S))* Math.sin(M)
				+ (0.019993 - S*0.000101)* Math.sin(2*M) + 0.000289* Math.sin(3*M);
		//	anomalieV_dg = M_dg + C_dg; // inutilisé		
		return  L_dg + C_dg;
	}

	/*
	longitude perihelie orbite de la Terre a la date T en degres
		Ajouter 180 pour avoir la longitude du perigee du Soleil.
	Entree :
		siecle julien du calcul : S  = (je-2451545)/36525;
	Sorties :
		longitude du perihelie de l'orbite de la Terre a la date S en dg
	 */
	public static double earth_longiPerih_dg(double S)
	{
		return 102.93735 + S*(1.71946 + S*0.00046);
	}	
	/*
	eccentricite de l'orbite de la Terre à la date T
		Entree facultative :
			siecle julien du calcul : S  = (je-2451545)/36525;
		Sortie :
			exenT  : eccentricite de l'orbite de la Terre à la date T
		Remarque : C'est également celle de l'orbite du Soleil	
	 */
	public static double eccentricity(double S)
	{
		return 0.016708634 - S*(0.000042037 + S*0.0000001267);
	}	

	/**
	 *      Ecarts en coord. eclip. dus a l'aberration annuelle
	 * @param lamb    : Longitude écliptique à corriger
	 * @param beta_rd    : Latitude écliptique à corriger 
	 * @param lonSolV : longitude vraie du Soleil
	 * @param excenT  : eccentricité de l'orbite de la Terre à la date
	 * @param lperiT  : Longitude périhélie de l'orbite de la Terre 
	 * @param dBeta   : Référence pour retour de la variation de latitude
	 * @return        : Variation de longitude
	 */
	public static double aberrEcli_rd_std(double lamb, double beta_rd,
			double lonSolV, double excenT, double lperiT, double dBeta[])
	{
		double Kappa = 0.99364e-4;  // 20.4952 secondes de degrés convertis en radians
		double lsml =  lonSolV - lamb; 
		double clsml = Math.cos(lsml);
		double slsml = Math.sin(lsml);
		double pml = lperiT - lamb; 
		double cpml = Math.cos(pml);
		double spml = Math.sin(pml);
		double dLamb = -Kappa*(-clsml + excenT*cpml)/ Math.cos(beta_rd);;
		dBeta[0] = -Kappa* Math.sin(beta_rd)*(slsml - excenT*spml);
		return dLamb;
	}

	/**
	 *      Ecarts en coord. eclip. dus a l'aberration annuelle
	 * @param ju    : jour julien
	 * @param lamb_rd    : Longitude écliptique à corriger (en radians)
	 * @param beta_rd    : Latitude écliptique à corriger (en radians)
	 * @param dBeta   : Référence pour retour de la variation de latitude
	 * @return        : Variation de longitude
	 */
	public static double aberrEcli_rd_eco(double ju, double lamb_rd, double beta_rd, double dBeta[])
	{
		if (Math.abs(ju-juIni) > 1.) update_eco(ju);
		double Kappa = 0.99364e-4;  // 20.4952 secondes de degrés convertis en radians
		double lsml =  lonSolV_rd - lamb_rd;
		double clsml = Math.cos(lsml);
		double slsml = Math.sin(lsml);
		double pml = lonPeriT_rd - lamb_rd;
		double cpml = Math.cos(pml);
		double spml = Math.sin(pml);
		double dLamb = -Kappa*(-clsml + excenT*cpml)/ Math.cos(beta_rd);;
		dBeta[0] = -Kappa* Math.sin(beta_rd)*(slsml - excenT*spml);
		return dLamb;
	}

	/*
	Ecarts en coord. equat. dus a l'aberration annuelle
	Entrees :
		ra, dec : ascension droite et declinaison de l'etoile a corriger
		obliq   : obliquité vraie de l'écliptique
		lonSolV : longitude vraie du Soleil
		excenT  : eccentricity de l'orbite de la Terre a la date
		lperiT  : longitude périhélie de l'orbite de la Terre 
	Sorties :
		dAlpha, dDelta : variation a appliquer a ra et dec.
		TOUS LES ANGLES ENTREES ET SORTIES : EN RADIANS !!!!!!!!	
	 */
	public static double aberrEqua_rd_std(double ra, double dec,
			double obliq, double lonSolV, double excenT, double lperiT, double dDelta[])
	{
		double Kappa = 0.99364e-4;  // 20.4952 secondes de degrés convertis en radians
		double cosa = Math.cos(ra);
		double sina = Math.sin(ra);
		double cosDec = Math.cos(dec);
		double sinDec = Math.sin(dec);
		double cosEps = Math.cos(obliq);
		double sinEps = Math.sin(obliq);
		double cosLE = Math.cos(lonSolV);
		double sinLE = Math.sin(lonSolV);
		double A = cosa*cosEps;
		double C = sinEps*cosDec - cosEps*sina*sinDec;
		double D = cosa*sinDec;
		double dAlpha = -Kappa*(A*cosLE + sina*sinLE)/ Math.cos(dec);
		dDelta[0] = -Kappa*(C*cosLE + D*sinLE);
		double cosp = Math.cos(lperiT);
		double sinp = Math.sin(lperiT);
		double k = Kappa*excenT;
		dAlpha += k*(A*cosp + sina*sinp)/ Math.cos(dec);
		dDelta[0] +=  k*(C*cosp + D*sinp);
		return dAlpha;
	}

	/*
	Ecarts en coord. equat. dus a l'aberration annuelle avec utilisation
	des paramètres astronomiques courants
	Entrees :
		ra, dec : ascension droite et declinaison de l'etoile a corriger
	Sorties :
		dAlpha, dDelta : variation a appliquer a ra et dec.
		TOUS LES ANGLES ENTREES ET SORTIES : EN RADIANS !!!!!!!!	
	 */
	public static double aberrEqua_rd_eco(double ju, double ra, double dec, double dDelta[])
	{
		if (Math.abs(ju-juIni) > 1.) update_eco(ju);
		double Kappa = 0.99364e-4;  // 20.4952 secondes de degrés convertis en radians
		double cosa = Math.cos(ra);
		double sina = Math.sin(ra);
		double cosDec = Math.cos(dec);
		double sinDec = Math.sin(dec);
		double A = cosa*cosEps;
		double C = sinEps*cosDec - cosEps*sina*sinDec;
		double D = cosa*sinDec;
		double dAlpha = -Kappa*(A*cosLES + sina*sinLES)/ Math.cos(dec);
		dDelta[0] = -Kappa*(C*cosLES + D*sinLES);
		double k = Kappa*excenT;
		dAlpha += k*(A*cosLPT + sina*sinLPT)/ Math.cos(dec);
		dDelta[0] +=  k*(C*cosLPT + D*sinLPT);
		return dAlpha;
	}

	/*
	Correction nutation en coordonnees equatoriales
	Entrees :
		ra, dec : ascension droite et declinaison de l'etoile a corriger
		obliq : obliquite vraie de l'écliptique
		dPsi, dEps : corrections nutation ecliptiques 
	Sorties :
		dAlpha, dDelta : variation a appliquer a ra et dec.
		Sortis dans la meme unite que dPsi et dEps
		!!!!!  ra, dec obliq et eps doivent etre en RADIANS  !!!!!
		!!!!!  dPsi et dEps doivent etre dans la meme unité (qcq)	 
	 */
	public static double nutationEqua(double ra, double dec, double obliq, 
			double dPsi, double dEps, double dDelta[])
	{
		double cosa = Math.cos(ra);
		double sina = Math.sin(ra);
		double cosDec = Math.cos(dec);
		double sinDec = Math.sin(dec);
		double cosEps = Math.cos(obliq);
		double sinEps = Math.sin(obliq);
		dDelta[0] = sinEps*cosa*dPsi + sina*dEps;
		return cosEps*dPsi + (sinEps*sina*dPsi - cosa*dEps)*sinDec/cosDec;
	}	

	/*
	Changement de date de coordonnees equatoriales
	Entrees : 
		alfa0, delta0 : coord. equat a l'epoque initiale en radians
		JD0 : jour julien dela premiere date (celle des coordonnees alfa0, delta0) 
		je  : jour julien de la date finale (celle des coordonnees a calculer)
	Sorties :
		alfa, delta : Coordonnees a la date finale, en radians	
	 */
	public static double chDateCoorEqua_rd_std(double alfa0_rd, double delta0_rd, double JD0,
			double je, double delta[])
	{
		double T0 = (JD0 - 2451545.0)/36525; // Siècle julien initial par rapport à J2000
		double S = (je-JD0)/36525;   // ecart en siecles juliens	
		double a = 2306.2181 + T0*(1.39656 - 0.000139*T0);
		double b = 0.30188-0.000344*T0;
		double zetaChg_rd = Math.toRadians(S*(a+S*(b+S*0.017998))/3600.); // en radians
		b = 1.09468+0.000066*T0;
		double zedeChg_rd = Math.toRadians(S*(a+S*(b+S*0.018203))/3600.); // en radians
		a = 2004.3109 - T0*(0.85330 + 0.000217*T0);
		b = 0.42665+0.000217*T0;
		double tetaChg_rd = Math.toRadians(S*(a+S*(-b-S*0.041883))/3600.); // en radians
		alfa0_rd +=  zetaChg_rd;
		double ca0z = Math.cos(alfa0_rd);
		double sa0z = Math.sin(alfa0_rd);
		double cd0 = Math.cos(delta0_rd);
		double sd0 = Math.sin(delta0_rd);
		double ctetChg = Math.cos(tetaChg_rd);
		double stetChg = Math.sin(tetaChg_rd);
		double A = ctetChg*cd0*ca0z - stetChg*sd0;
		double B = cd0*sa0z;
		double C = stetChg*cd0*ca0z + ctetChg*sd0;
		delta[0] = Math.asin(C);
		return zedeChg_rd + Math.atan2(B,A);
	}

	/*
	Changement de date de coordonnees equatoriales par rapport à J2000
	avec utilisation des paramètres astronomiques a variation lente
	Entrees : 
		alfa0, delta0 : coord. equat a l'epoque initiale en radians
	Sorties :
		alfa, delta : Coordonnees a la date finale, en radians	
	 */
	public static double chDateCoorEqua_rd_eco(double ju, double alfa0_rd, double delta0_rd, double delta[])
	{
		if (Math.abs(ju-juIni) > 1.) update_eco(ju);
		alfa0_rd +=  zetaChg_rd;
		double ca0z = Math.cos(alfa0_rd);
		double sa0z = Math.sin(alfa0_rd);
		double cd0 = Math.cos(delta0_rd);
		double sd0 = Math.sin(delta0_rd);
		double A = ctetChg*cd0*ca0z - stetChg*sd0;
		double B = cd0*sa0z;
		double C = stetChg*cd0*ca0z + ctetChg*sd0;
		delta[0] = Math.asin(C);
		return zedeChg_rd + Math.atan2(B,A);
	}

	/*	
	Coord. equatoriales apparentes dans le repère équatorial de la date
	Entrees :
		ju      : Date en jour julien TU
    	adt_rd, det_rd : Coord. equ à ju dans J2000.         
    	vA_rda, vD_rda : Vitesse des coord. en rd/an        
	Sorties : 
		ra_rd, de_rd  : coord. equ. apparentes dans le repère de la date
	Tous les angles sont en radians
	 */
	public static double equaJ0toApp_rd_std (double ju, double adt_rd, double det_rd, double tde_dg[])
	{
		// Calcul correction coordonnées équatoriales moyennes entre J2000 et la date
		double ra_rd, de_rd, tabde[] = {0};
		double je = ju + Utils.jul2deltaT(ju);
		ra_rd = chDateCoorEqua_rd_std(adt_rd, det_rd, 2451545, je, tabde); de_rd = tabde[0];		
		// Calcul correction nutation en coordonnées écliptiques
		double dpsi_rd, dobliq_rd, tabdob[] = {0};
		dpsi_rd = nutationEcli_rd(je, true, tabdob); dobliq_rd = tabdob[0];
		// Obliquité vrai à cette date
		double obliq_rd = Math.toRadians(obliquity_dg(je)) + dobliq_rd;
		// Calcul correction nutation en coordonnées equatoriales
		double dAlpha1_rd, dDelta1_rd, tabDelta[] = {0};
		dAlpha1_rd = nutationEqua(ra_rd, de_rd, 
				obliq_rd, dpsi_rd, dobliq_rd, tabDelta);
		dDelta1_rd = tabDelta[0];
		// Calcul aberration
		double dAlpha2_rd, dDelta2_rd;
		double S = (je - 2451545)/36525.;		
		dAlpha2_rd = aberrEqua_rd_std(ra_rd, de_rd, obliq_rd, Math.toRadians(sun_longi_dg(S)),
				eccentricity(S), Math.toRadians(earth_longiPerih_dg(S)), tabDelta);
		dDelta2_rd = tabDelta[0];
		// Coordonnées équatoriales apparentes
		tde_dg[0] = de_rd + dDelta2_rd + dDelta1_rd;
		return ra_rd + dAlpha2_rd + dAlpha1_rd;
	}	

	/*	
	Coord. equatoriales apparentes dans le repère équatorial de la date utilisant les
	paramètres astronomiques courants
	Entrees :
		ju      : Date en jour julien UT
    	adt_rd,
    	det_rd : Coord. equ à J2000 dans J2000.         
    	vA_rda, vD_rda : Vitesse des coord. en rd/an        
	Sorties : 
		ra_rd, de_rd  : coord. equ. apparentes dans le repère de la date
	Tous les angles sont en radians
	 */
	public static double equaJ0toApp_rd_eco (double ju, double adt_rd, double det_rd, double tde_dg[])
	{
		if (Math.abs(ju-juIni) > 1.) update_eco(ju);
		// Calcul correction coordonnées équatoriales moyennes entre J2000 et la date
		double ra_rd, de_rd, tabde[] = {0};
		ra_rd = chDateCoorEqua_rd_eco(ju, adt_rd, det_rd, tabde); de_rd = tabde[0];		
		// Calcul correction nutation en coordonnées equatoriales
		double dAlpha1_rd, dDelta1_rd, tabDelta[] = {0};
		dAlpha1_rd = nutationEqua(ra_rd, de_rd, obli_rd, dpsi_rd, dobli_rd, tabDelta);
		dDelta1_rd = tabDelta[0];
		// Calcul aberration
		double dAlpha2_rd, dDelta2_rd;
		dAlpha2_rd = aberrEqua_rd_eco(ju, ra_rd, de_rd, tabDelta);
		dDelta2_rd = tabDelta[0];
		// Coordonnées équatoriales apparentes
		tde_dg[0] = de_rd + dDelta2_rd + dDelta1_rd;
		return ra_rd + dAlpha2_rd + dAlpha1_rd;
	}	
	
	/**
	 *    Transformation coord. écliptiques en coordonnées équatoriales
	 * @param lambda_rd  : longitude écliptique
	 * @param beta_rd    : latitude écliptique
	 * @param obli_rd  : Obliquité
	 * @param decli_rd  : pointeur pour le retour de la déclinaison
	 * @return         : l'ascension droite
	 */
	public static double ecli2equa_rd(double lambda_rd, double beta_rd, double obli_rd, double []decli_rd)
	{
		double ce = Math.cos(obli_rd);
		double se = Math.sin(obli_rd);
		double sl = Math.sin(lambda_rd);
		double cl = Math.cos(lambda_rd);
		double sb = Math.sin(beta_rd);
		double cb = Math.cos(beta_rd);
		decli_rd[0] = Math.asin(se*sl*cb + ce*sb);
		return Math.atan2(ce*sl*cb - se*sb, cl*cb);
	}
	
	/**
	 *    Transformation coord. équatoriales apparentes en coordonnées topographiques
	 * @param ju       : jour julien UT
	 * @param alfa_rd  : ascension droite de l'astre
	 * @param decli_rd : déclinaison de l'astre
	 * @param longi_rd : longitude du lieu d'observation
	 * @param lati_rd  : latitude du lieu d'observation
	 * @param ttopo    : référence pour retours azimut_rd, hauteur_rd et hauteurCor_dg
	 * @param eco      : true => utilisation paramètres variants lentement
	 * @return         : angle horaire de l'astre
	 */
	public static double equa2topo_rd(double ju, double alfa_rd, double decli_rd, 
			double longi_rd, double lati_rd, double ttopo[], boolean eco)
	{
		double hourAng_rd = Math.toRadians(jul2alst_dg(ju, Math.toDegrees(longi_rd), eco)) - alfa_rd;
		double cosHA = Math.cos(hourAng_rd);
		double sinHA = Math.sin(hourAng_rd);
		double cosDE = Math.cos(decli_rd);
		double sinDE = Math.sin(decli_rd);
		double cosLa = Math.cos(lati_rd);
		double sinLa = Math.sin(lati_rd);
		double azi_rd = Math.atan2(sinHA*cosDE, cosHA*sinLa*cosDE - sinDE*cosLa);
		double haut_rd = Math.asin(sinLa*sinDE + cosLa*cosDE*cosHA);
		double haut_dg = Math.toDegrees(haut_rd);
		double dh_dg = refraction_dg(haut_dg);
		double hautCor_dg = haut_dg + dh_dg;	
		ttopo[0] = azi_rd;
		ttopo[1] = haut_rd;
		ttopo[2] = hautCor_dg;
		return hourAng_rd;
	}

	/**
	 *    Transforamation coord. topographiques en équatoriales / rep J0
	 *    Cette routine permet de trouver la direction dans J0 d'une
	 *    direction de visée de l'observateur, par exemple pour mesurer
	 *    l'écart par rapport aux directions des astres connues dans J0
	 * @param ju       : jour julien UT
	 * @param azi_rd   : azimut de l'astre
	 * @param sit_rd   : haut visuelle de l'astre
	 * @param longi_rd : longitude du lieu d'observation
	 * @param lat_rd  : latitude du lieu d'observation
	 * @param tdelta   : référence pour retour decli_rd
	 * @param eco      : true => utilisation paramètres variants lentement
	 * @return         : l'ascension droite / J0 en radian
	 */		
	public static double topo2equaJ0_rd(double ju, double azi_rd, double sit_rd, 
			double longi_rd, double lat_rd, double tdelta[], boolean eco)
	{

		double clat = Math.cos(lat_rd);
		double slat = Math.sin(lat_rd);
		double cazi = Math.cos(azi_rd);
		double sazi = Math.sin(azi_rd);
		// Correction refraction atmosphérique
		double site_dg = Math.toDegrees(sit_rd);
		site_dg -= refraction_dg(site_dg, false); // false car site observé
		// Angle horaire apparent
		sit_rd = Math.toRadians(site_dg);
		double csit = Math.cos(sit_rd);
		double ssit = Math.sin(sit_rd);
		double H_rd = Math.atan2(sazi, slat*cazi + clat*ssit/csit);
		// Coordonnées équatoriales apparentes
		double delta_rd = Math.asin(slat*ssit-clat*cazi*csit);
		double ra_rd;
		double agst_dg = jul2agst_dg(ju, eco);
		double alfa_rd = Math.toRadians(agst_dg) + longi_rd - H_rd;
		if (eco)
		{
			// Obliquité vrai à cette date		
			double dAlpha_rd, dDelta_rd, tabDelta[] = {0};
			// Calcul correction nutation et aberration (à enlever)
			dAlpha_rd = aberrEqua_rd_eco(ju, alfa_rd, delta_rd, tabDelta);			
			dDelta_rd = tabDelta[0];
			alfa_rd -= dAlpha_rd; delta_rd -= dDelta_rd; 
			dAlpha_rd = nutationEqua(alfa_rd, delta_rd, obli_rd, dpsi_rd, dobli_rd, tabDelta);
			dDelta_rd = tabDelta[0];		
			alfa_rd -= dAlpha_rd; delta_rd -= dDelta_rd; 
			// remontée aux coordonnées équatoriales dans J2000
			ra_rd = chDateCoorEqua_rd_std(alfa_rd, delta_rd, ju + deltaT, 2451545, tdelta);   	
		}
		else
		{
			// Remontée aux coordonnées équatoriales moyennes
			double je = ju + Utils.jul2deltaT(ju);
			// Calcul correction nutation en coordonnées écliptiques
			double dpsi_rd, dobliq_rd, tabdob[] = {0};
			dpsi_rd = nutationEcli_rd(je, false, tabdob); // true pour calculs hyper-précis
			dobliq_rd = tabdob[0];
			// Obliquité vrai à cette date
			double obliq_rd = Math.toRadians(obliquity_dg(je)) + dobliq_rd;
			double S = (je - 2451545)/36525.;			
			double dAlpha_rd, dDelta_rd, tabDelta[] = {0};
			// Calcul correction nutation et aberration (à enlever)
			dAlpha_rd = aberrEqua_rd_std(alfa_rd, delta_rd, obliq_rd, 
					Math.toRadians(sun_longi_dg(S)),
					eccentricity(S), Math.toRadians(earth_longiPerih_dg(S)), tabDelta);
			dDelta_rd = tabDelta[0];
			alfa_rd -= dAlpha_rd; delta_rd -= dDelta_rd; 
			dAlpha_rd = nutationEqua(alfa_rd, delta_rd, obliq_rd, dpsi_rd, dobliq_rd, tabDelta);
			dDelta_rd = tabDelta[0];		
			alfa_rd -= dAlpha_rd; delta_rd -= dDelta_rd; 
			// remontée aux coordonnées équatoriales dans J2000
			ra_rd = chDateCoorEqua_rd_std(alfa_rd, delta_rd, je, 2451545, tdelta);   	
		}
		return ra_rd;
	}

	public static void starsUpdate(Star[]tabStars, double ju)
    {


    }

	public static void main(String[] args) {
/*		
		double ju = 2431559.7;
		System.out.println("deltaT = " + Utils.jul2deltaT_s(ju));
		double ad0_rd = 1.38182080203521;
		double de0_rd = 0.802817518959714;
		double vA_rda = 5.30398056567319e-007;
		double vD_rda =  -2.06045814471553e-006;
		double t = (ju - 2451545)/365.25;
		double adt_rd = ad0_rd + vA_rda*t;
		double det_rd = de0_rd + vD_rda*t;				
		double ad_rd, de_rd, tde_rd[]={0};
		ad_rd = equaJ0toApp_rd_std (ju, adt_rd, det_rd, tde_rd);
		de_rd = tde_rd[0];
		System.out.println("ad_rd = " + Utils.deg2hms(Math.toDegrees(ad_rd)));
		System.out.println("de_rd = " + Utils.deg2dms(Math.toDegrees(de_rd)));
*/
		for (double h = -80; h <= 1; h+= 1)
		{
			double hc = h  + refraction_dg(h);
			System.out.println ("h = " + h + ", hcor = " + hc);
		}
	}
}


