package fr.llibre.simastro;

import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.ActivityCompat;
//import androidx.core.content.ContextCompat;

import android.Manifest;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.DashPathEffect;
import android.graphics.Paint;
import android.graphics.Path;
import android.graphics.RectF;
import android.location.Criteria;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.os.Handler;
import android.os.Parcel;
import android.os.Parcelable;
import android.provider.Settings;
import android.text.Editable;
import android.text.Html;
import android.text.TextWatcher;
import android.view.Gravity;
import android.view.MotionEvent;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.ScrollView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import java.io.InputStream;
import java.io.InputStreamReader;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Timer;
import java.util.TimerTask;

import fr.llibre.ml2.Astro;
import fr.llibre.ml2.Celobj;
import fr.llibre.ml2.Etoile;
import fr.llibre.ml2.Moon;
import fr.llibre.ml2.Planet;
import fr.llibre.ml2.R3;
import fr.llibre.ml2.Sater;
import fr.llibre.ml2.Star;
import fr.llibre.ml2.SysSolar;
import fr.llibre.ml2.Terrien;
import fr.llibre.ml2.TwoLE;
import fr.llibre.ml2.Utils;

import static java.lang.Thread.sleep;

public class MainActivity extends AppCompatActivity {

    private final int CODE_SELECTSTARS = 3157;
    private final int CODE_SELECTPLANETS = 3158;
    private final int CODE_SELECTCELOBJ = 3159;
    private final int CODE_VISEEACQ = 3160;
    private final int CODE_SELECTSATELS = 3161;
    private Star bigStars[];
    private Celobj tabCelobj[];
    private Moon moonSel = null;
    private Star starSel = null;
    private Planet planetSel = null;
    private Celobj celobjSel = null;
    private Sater satSel = null;
    private TextView textViewLoc, textVisee, tvDate, tvSidGr, tvPolaire;
    private LinearLayout bigLayout, smallLayout, locLayout;
    private ScrollView scrollView;
    int indexViewChoix;
    int indexLocView;
    int indexSmallLayout;
    private TextView textScroll;
    private ViewSSol2D viewSSol2D;
    private ViewCiel2D viewCiel2D;
    boolean ssol2Dpret = false;
    boolean ciel2Dpret = false;
    private double latitude_dg = 43.5411;
    private double longitude_dg = 1.60906;
    private double azimut_dg = 0.;
    private double site_dg = 30.;
    float azimut_rd = (float) Math.toRadians(azimut_dg);
    float site_rd = (float) Math.toRadians(site_dg);
    private boolean flagSexa = true; // si sexagesimal, sinon décimal
    private int numUniteUsg = 0; // 0 24h, 1 +-12h
    private double julNow; // date TU actuelle du système
    private double kTimeAccel;
    private double julNow0; // date TU actuelle au démarrage
    private double julSim; // date TU de travail
    private double julSim0; // date TU de travail au démarrage
    private double julLoc; // date locale de travail
    private double mgst_dg, agst_dg;
    private int annee, mois, jour, heure, minute;
    private double seconde;
    EditText edJour, edMois, edAnnee, edHeure, edMinute, edSeconde;
    private Timer myTimer, timerInDiag;
    private int period;
    private boolean timerOn;
    private Handler myHandler;
    private EditText edLongi, edLati;
    private EditText edAzimut, edSite;
    private Button buttonAM;
    private Button buttonAR;
    private Spinner spinChoix;
    double uvwr[][] = new double[9][4];
    double[] longip = new double[9];
    private String oriPos = "Man";
    private static final String[] strChoix = {"Infos", "SSol", "Ciel"};
    private int choixCourant;

    private void splitJul(double jul) {
        int[] mo = {0};
        int[] an = {0};
        int[] he = {0};
        int[] mn = {0};
        double[] jdec = {0.};
        double ss[] = {0.};
        Utils.jul2dat(jul, jdec, mo, an);
        annee = an[0];
        mois = mo[0];
        jour = (int) jdec[0];
        Utils.jdec2hms(jdec[0], he, mn, ss);
        heure = he[0];
        minute = mn[0];
        seconde = ss[0];
    }

    // Calcul du temps de la simulation
    private void updateTime() {
        // Nb de milli-secondes a 1.1.1970-0h
        julNow = (new Date().getTime() / 1000. - 946728000.) / 86400. + 2451545.;
        if (julNow0 < 0) julNow0 = julNow;
        if (julSim0 < 0) julSim0 = julNow;
        julSim = julSim0 + kTimeAccel * (julNow - julNow0);
        mgst_dg = Astro.jul2mgst_dg(julSim); // temps sideral moyen de Greenwich
        agst_dg = mgst_dg + Astro.deltaTsg_dg; // temps sideral apparent de Greenwich
        Calendar cal = Calendar.getInstance();
        julLoc = julSim + (cal.get(Calendar.ZONE_OFFSET) +
                cal.get(Calendar.DST_OFFSET)) / (1000. * 86400.);
        splitJul(julSim);
        if (!timerOn) synchroAffichage();
    }

    //**********************************************************************
    // Classe Timer rafraichissant la date toute les secondes
    // S'execute dans un thread qui n'a pas acces a l'UI !!
    private class MyTimerTask extends TimerTask {
        @Override
        public void run() {
            updateTime();
            // On reveille runnable_SyncAffich avec la nouvelle date
            myHandler.post(runnable_SyncAffich);
        }
    }

    ;
    //**********************************************************************
    // Methode Runnable appelée par la classe Timer 1 ou 10 fois par second mais
    // qui appartenant à la classe class MainActivity et donc s'execute dans
    // le thread principal pour avoir acces a l'UI.
    private Runnable runnable_SyncAffich = new Runnable() {
        @Override
        public void run() {
            synchroAffichage();
        }
    };

    public void synchroAffichage() {
        String text;
        DecimalFormatSymbols dfs = new DecimalFormatSymbols();
        dfs.setDecimalSeparator('.');
        DecimalFormat df4 = new DecimalFormat("0.0000", dfs);
        // Jour julien GMT
        text = "Heure GMT : " + Utils.jul2str1(julSim) + "\n";
        // Decalage / Greenwich (UT - GMT)
        text += "Heure locale : " + Utils.jul2str1(julLoc);
        tvDate.setText(text);
        if (choixCourant == 0) // Cas affichage textes
        {
            ssol2Dpret = false;
            ciel2Dpret = false;
            double alst_dg = agst_dg + longitude_dg; // temps sidéral apparent local
            if (numUniteUsg == 0) {
                text = "Heure sid. moy. Grenwich : " + Utils.deg2hms(mgst_dg) + "\n";
                text += "Heure sid. app. Grenwich : " + Utils.deg2hms(agst_dg) + "\n";
                text += "Heure sid. app. locale   : " + Utils.deg2hms(alst_dg);
            } else {
                text = "Heure sid. moy. Grenwich : " + Utils.deg2hms2(mgst_dg) + "\n";
                text += "Heure sid. app. Grenwich : " + Utils.deg2hms2(agst_dg) + "\n";
                text += "Heure sid. app. locale   : " + Utils.deg2hms2(alst_dg);
            }
            tvSidGr.setText(text);

            double hA_dg, tHA_dg[] = {0};
            double pol_dg = Astro.polarisInScope_dg(julSim, longitude_dg, tHA_dg, true);
            hA_dg = tHA_dg[0];
            if (flagSexa) {
                text = "Angle horaire polaire : " + Utils.deg2hms(hA_dg) + "\n";
                text += "Polaris in Scope : " + Utils.deg2hms(pol_dg);
            } else {
                text = "Angle horaire polaire : " + df4.format(hA_dg / 15.) + "h\n";
                text += "Polaris in Scope : " + df4.format(pol_dg / 15.) + "h";
            }
            tvPolaire.setText(text);

            int sexaDec = flagSexa ? 1 : -1;
            if (starSel != null || planetSel != null || celobjSel != null
                    || moonSel != null || satSel != null)
                textScroll.setGravity(Gravity.CENTER);
            if (starSel != null) {
                String nom = starSel.nom.trim();
                if (nom.length() == 0) nom = starSel.id.trim();
                String cons = Astro.nomConstelsFrLong[starSel.ixCons];
                text = "Informations sur " + nom + " dans " + cons + "\n";
                text += starSel.infos(julSim, longitude_dg, latitude_dg, sexaDec, true);
                textScroll.setText(text);
            }
            if (planetSel != null) {
                text = "Informations sur " + planetSel.nom + "\n";
                text += planetSel.infos(julSim, longitude_dg, latitude_dg, sexaDec, true, true);
                textScroll.setText(text);
            }
            if (celobjSel != null) {
                String nom = celobjSel.id;
                if (nom.startsWith("M")) nom = "Messier " + nom.substring(1);
                if (nom.startsWith("C")) nom = "Caldwell " + nom.substring(1);
                if (nom.startsWith("N")) nom = "NGC" + nom.substring(1);
                if (nom.startsWith("I")) nom = "IC" + nom.substring(1);
                String cons = Astro.nomConstelsFrLong[celobjSel.ixCons];
                text = "Info. sur " + nom + " dans " + cons + "\n";
                if (celobjSel.nom.length() > 0) text += "alias : " + celobjSel.nom + "\n";
                text += celobjSel.infos(julSim, longitude_dg, latitude_dg, sexaDec, true);
                textScroll.setText(text);
            }
            if (moonSel != null) {
                text = "Informations sur la Lune\n";
                text += Moon.infos(julSim, longitude_dg, latitude_dg, sexaDec, true);
                textScroll.setText(text);
            }
            if (satSel != null) {
                text = "Informations sur le satellite " + satSel.name + "\n";
                // altitude 0. Il faudra la demander.
                text += satSel.infos(julSim, longitude_dg, latitude_dg, 0., sexaDec);
                textScroll.setText(text);
            }
        } else // Cas affichage graphiques
        {
            if (Math.abs(julSim - Astro.juIni) > 1.) { Astro.update_eco(julSim);}
            // Coordonnées planetes , soleil, Lune

            if (choixCourant == 1)
            {
                uvwr = SysSolar.coordEcliGeo(julSim);
                for (int i = 0; i < 9; i++) longip[i] = Math.atan2(uvwr[i][1], uvwr[i][0]);
                ssol2Dpret = true;
                viewSSol2D.invalidate();
            } else // Cas du Ciel2D
            {
                Terrien.update(julSim);
                uvwr = SysSolar.coordEquaGeo(julSim);
                Etoile.updateAlluCS(bigStars, julSim);
                if (satSel != null) satSel.update(julSim);
                ciel2Dpret = true;
                viewCiel2D.invalidate();
            }
        }
    }

    // ON CREATE
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        bigLayout = (LinearLayout) findViewById(R.id.bigLayout);
        smallLayout = (LinearLayout) findViewById(R.id.smallLayout);
        locLayout = (LinearLayout) findViewById(R.id.locLayout);
        textViewLoc = (TextView) findViewById(R.id.textViewLoc); // pour ecrire un status de l'accès aux fichiers.
        textVisee = (TextView) findViewById(R.id.textVisee); // pour ecrire un status de l'accès aux fichiers.
        tvDate = (TextView) findViewById(R.id.textViewDate);
        tvSidGr = (TextView) findViewById(R.id.textViewSidGr);
        scrollView = (ScrollView) findViewById(R.id.scrollView1);
        textScroll = (TextView) findViewById(R.id.textInScro);
        tvPolaire = (TextView) findViewById(R.id.textViewPolar);
        buttonAM = (Button) findViewById(R.id.buttonAM);
        buttonAR = (Button) findViewById(R.id.butSens);
        spinChoix = (Spinner) findViewById(R.id.spinner2);
        indexViewChoix = bigLayout.indexOfChild(scrollView);
        indexLocView = bigLayout.indexOfChild(locLayout);
        indexSmallLayout = bigLayout.indexOfChild(smallLayout);

        ArrayAdapter<String> aa = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, strChoix);
        aa.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinChoix.setAdapter(aa);
        choixCourant = 0;
        spinChoix.setOnItemSelectedListener(
                new Spinner.OnItemSelectedListener() {
                    public void onNothingSelected(AdapterView<?> parent) {
                    }

                    public void onItemSelected(AdapterView<?> parent, View v, int pos, long id) {
                        if (pos == choixCourant) return; // Rien à faire
                        period = pos == 0 ? 1000 : 67;
                        // Si timer en marche, on arrete et redémarre pour prise en compte nouvelle periode
                        if (timerOn) {
                            onClickAM(null);
                            onClickAM(null);
                        }
                        // On remet les affichages textes qu'on enlèvera à nouveau si graphique
                        if (choixCourant != 0) {
                            bigLayout.addView(locLayout, indexLocView);
                            bigLayout.addView(smallLayout, indexSmallLayout);
                        }
                        // On enlève la vue choix qui est à remplacer
                        bigLayout.removeViewAt(indexViewChoix);
                        // On la remplace par la vue choisie
                        switch (pos) {
                            case 0: // Affichage "Infos"
                                bigLayout.addView(scrollView, indexViewChoix);
                                break;
                            case 1: // Affichage Système solaire
                                bigLayout.addView(viewSSol2D, indexViewChoix);
                                break;
                            case 2: // Affichage Ciel étoilé
                                bigLayout.addView(viewCiel2D, indexViewChoix);
                                break;
                        }
                        if (pos != 0) // Si graphique, on enlève les affichages textes
                        {
                            // On enlève les affichages textes
                            bigLayout.removeViewAt(indexSmallLayout);
                            bigLayout.removeViewAt(indexLocView);
                        }
                        choixCourant = pos;
                    }
                }
        );
        viewSSol2D = new ViewSSol2D(this);
        viewCiel2D = new ViewCiel2D(this);
        // Configuration de l'acces à la localisation
        // majCoordonnees();
        // Affichage direction de visee privilégiée
        affichVisee();

        // Calcul parametres Astro variant lentement
        //-------------------------------------------
        updateTime();
        // Initialisation position obseravteur
        Terrien.setLocal_rdm(julSim, Math.toRadians(longitude_dg), Math.toRadians(latitude_dg), 0.);
        Astro.update_eco(julSim); // permet d'appeler en mode eco autour de la date donnée
        // Lecture des Tableaux d'étoiles dans les ressources
        //---------------------------------------------------
        try {
            InputStreamReader ir310, irCelobj;
            // Lecture fichier 310stars
            InputStream in310 = getResources().openRawResource(R.raw.mllstarscons);
            ir310 = new InputStreamReader(in310, "UTF-8");
            bigStars = Star.loadMesStars(ir310,3693);
            in310.close();
            if (bigStars.length != 3693) {
                Toast.makeText(this, "Trouvé " + bigStars.length + "étoiles\ndans le tableau des étoiles !", Toast.LENGTH_LONG).show();
                finish();
            }

            // Lecture fichier objets célestes
            InputStream inCelobj = getResources().openRawResource(R.raw.mll340objcels);
            irCelobj = new InputStreamReader(inCelobj, "UTF-8");
            tabCelobj = Celobj.loadObjCels(irCelobj);
            inCelobj.close();
            if (tabCelobj.length != 340) {
                Toast.makeText(this, "Trouvé " + tabCelobj.length + "objets\ndans le tableau d'objets Célestes !", Toast.LENGTH_LONG).show();
                finish();
            }
        } catch (Throwable t) {
            Toast.makeText(this, "Exception: " + t.toString(), Toast.LENGTH_LONG).show();
            finish();
        }
        buttonAM.setText("Pause");
        buttonAR.setText("Inverse");
        resetChoixAffichage();

        // Lancement tache rafraichissement de l'horloge
        //----------------------------------------------
        julNow0 = -1; // Il est à initialiser
        julSim0 = -1; // Il est à initialiser
        kTimeAccel = 1.;
        myHandler = new Handler();
        myTimer = new Timer();
        period = 1000;
        myTimer.scheduleAtFixedRate(new MyTimerTask(), 0, period);
        timerOn = true;
    }

    void resetChoixAffichage() {
        moonSel = null;
        starSel = null;
        planetSel = null;
        celobjSel = null;
        satSel = null;
    }

    // Calback ecouteurs Maj ccordonnées
    /* GPS Constant Permission */
    private static final int MY_PERMISSION_ACCESS_COARSE_LOCATION = 11;
    private static final int MY_PERMISSION_ACCESS_FINE_LOCATION = 12;

    // Cette fonction ne marche plus sur les version d'ANDROID postérieures à 2018
    public void majCoordonnees() {
        boolean okLoc = false;
        oriPos = "Man";
        LocationManager mLocationManager = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
        if (mLocationManager != null) {
            Toast.makeText(this, "LocationManager non null", Toast.LENGTH_LONG).show();
            Criteria criteria = new Criteria();
            criteria.setAccuracy(Criteria.ACCURACY_FINE);
            String mProviderName = mLocationManager.getBestProvider(criteria, true);

            // API 23: Il faut vérifier si les permissions ACCESS_FINE_LOCATION et/ou ACCESS_COARSE_LOCATION sont autorisées
            if (ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_FINE_LOCATION)
                    == PackageManager.PERMISSION_GRANTED) {
                okLoc = true;
                oriPos = "GPS";
            } else if (ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_COARSE_LOCATION)
                    == PackageManager.PERMISSION_GRANTED) {
                okLoc = true;
                oriPos = "GSM";
            }
            if (okLoc) { // On a l'autorisation
                if (mProviderName == null || mProviderName.equals("")) // Pas de provider activaté: on interroge le GPS
                {
                    textViewLoc.setText("Interrogation du service localisation !\n");
                    startActivity(new Intent(Settings.ACTION_LOCATION_SOURCE_SETTINGS));
                }
                // Au moins un provider actif. On récupère les coordonnées (10000 ms, 500 m)
                // mLocationManager.requestLocationUpdates(mProviderName, 10000, 500, this);
                try {
                    Location location = mLocationManager.getLastKnownLocation(mProviderName);
                    if (location != null) {
                        latitude_dg = location.getLatitude();
                        longitude_dg = location.getLongitude();
                        //				altitude = location.getAltitude();
                        Terrien.setLocal_rdm(julSim, Math.toRadians(longitude_dg), Math.toRadians(latitude_dg), 0.);
                        affichPosition(oriPos);
                    } else {
                        textViewLoc.setText("Attente mise en service localisation !\n");
                        mLocationManager.requestSingleUpdate(mProviderName, onLocationChange, null);
                    }
                } catch (SecurityException e) {
                    textViewLoc.setText("SECURITY EXCEPTION : AUTORISATION NON ACCORDEE !!!!\n");
                }
                // One or both permissions are denied.
            } else // On a pas l'autorisation d'accéder à la localisation, on les demande
            {
                // The ACCESS_COARSE_LOCATION is denied, then I request it and manage the result in
                if (ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_COARSE_LOCATION) !=
                        PackageManager.PERMISSION_GRANTED) {
                    ActivityCompat.requestPermissions(this,
                            new String[]{Manifest.permission.ACCESS_COARSE_LOCATION}, MY_PERMISSION_ACCESS_COARSE_LOCATION);
                }
                // The ACCESS_FINE_LOCATION is denied, then I request it and manage the result in
                if (ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_FINE_LOCATION)
                        != PackageManager.PERMISSION_GRANTED) {
                    ActivityCompat.requestPermissions(this,
                            new String[]{Manifest.permission.ACCESS_FINE_LOCATION},
                            MY_PERMISSION_ACCESS_FINE_LOCATION);
                }
            }
        } else {
            textViewLoc.setText("Echec accès LocationManager\n");
            return;
        }
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, String permissions[], int[] grantResults) {
        switch (requestCode) {
            case MY_PERMISSION_ACCESS_COARSE_LOCATION:
            case MY_PERMISSION_ACCESS_FINE_LOCATION:
                if (grantResults.length > 0 && grantResults[0] == PackageManager.PERMISSION_GRANTED)
                    textViewLoc.setText("Acces localisation, autorisée. Refaire <ICI>\n");
                else
                    textViewLoc.setText("Acces localisation non autorisé.\nEntrer manuellement la localisation par <LOC>\n");
                break;
        }
    }

    // Dialog acquisition décalage DATE-TIME
    public void onClickNewDateTime(View v) {
        if (timerOn) onClickAM(null); // On arrête le timer s'il est en marche
        View view = (LinearLayout) LinearLayout.inflate(this, R.layout.date_dialog, null);
        edJour = (EditText) view.findViewById(R.id.edJour);
        edMois = (EditText) view.findViewById(R.id.edMois);
        edAnnee = (EditText) view.findViewById(R.id.edAnnee);
        edHeure = (EditText) view.findViewById(R.id.edHeure);
        edMinute = (EditText) view.findViewById(R.id.edMinute);
        edSeconde = (EditText) view.findViewById(R.id.edSeconde);
        // Nb de milli-secondes a 1.1.1970-0h
        int[] mo = {0};
        int[] an = {0};
        int[] he = {0};
        int[] mn = {0};
        double[] jdec = {0.};
        double ss[] = {0.};
        Utils.jul2dat(julSim, jdec, mo, an);
        edJour.addTextChangedListener(new EditWatcher(edJour, 31));
        edJour.setText(String.valueOf((int) jdec[0]));
        edMois.addTextChangedListener(new EditWatcher(edMois, 12));
        edMois.setText(String.valueOf(mo[0]));
        edAnnee.addTextChangedListener(new EditWatcher(edAnnee, 9999));
        edAnnee.setText(String.valueOf(an[0]));
        Utils.jdec2hms(jdec[0], he, mn, ss);
        edHeure.addTextChangedListener(new EditWatcher(edHeure, 23));
        edHeure.setText(String.valueOf(he[0]));
        edMinute.addTextChangedListener(new EditWatcher(edMinute, 59));
        edMinute.setText(String.valueOf(mn[0]));
        edSeconde.addTextChangedListener(new EditWatcher(edSeconde, 59));
        edSeconde.setText(String.valueOf(Math.round(ss[0])));

        AlertDialog.Builder aldb = new AlertDialog.Builder(this);
        aldb.setTitle("Changement d'époque");
        aldb.setView(view); // Le layout d'édition est affiché dans l'alertDialog
        aldb.setPositiveButton("OK",
                new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int whichButton) {
                        // Traitement à faire avant sortie par clic sur Ok
                        try {
                            annee = Integer.parseInt(edAnnee.getText().toString());
                            mois = Integer.parseInt(edMois.getText().toString());
                            jour = Integer.parseInt(edJour.getText().toString());
                            heure = Integer.parseInt(edHeure.getText().toString());
                            minute = Integer.parseInt(edMinute.getText().toString());
                            seconde = Integer.parseInt(edSeconde.getText().toString());
                            julSim0 = Utils.dat2jul(annee, mois, jour, heure, minute, seconde);
                            julNow0 = julNow;
                            updateTime();
                            Astro.update_eco(julSim); // permet d'appeler en mode eco autour de la date donnée
                        } catch (NumberFormatException exception) {
                        }
                        onClickAM(null); // On remet le timer en marche
                    }
                }
        );
        aldb.setNegativeButton("Annuler",
                new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int whichButton) {
                        onClickAM(null); // On remet le timer en marche
                    }
                }
        );
        aldb.create().show();
    }

    // Classe permettant de limiter les entrées numériques dans les EditView du dialogue ci-dessus
    class EditWatcher implements TextWatcher {
        EditText ed;
        int maxVal;
        boolean ignoreChange = false;

        EditWatcher(EditText e, int maxValue) {
            ed = e;

            maxVal = maxValue;
        }

        @Override
        public void afterTextChanged(Editable s) {
        }

        @Override
        public void beforeTextChanged(CharSequence s, int start, int count, int after) {
        }

        @Override
        public void onTextChanged(CharSequence s, int start, int before, int count) {
            if (!ignoreChange) {
                boolean modif = false;
                try {
                    int val = Integer.parseInt(s.toString());
                    if (val > maxVal) modif = true;
                } catch (NumberFormatException exception) {
                    modif = true;
                }
                if (modif) {
                    ignoreChange = true;
                    ed.setText("");
                    ed.setSelection(ed.getText().length());
                    ignoreChange = false;
                }
            }
        }
    }

    // Récupération de la position GPS ou GSM
    LocationListener onLocationChange = new LocationListener() {
        public void onLocationChanged(Location location) {
            latitude_dg = location.getLatitude();
            longitude_dg = location.getLongitude();
            Terrien.setLocal_rdm(julSim, Math.toRadians(longitude_dg), Math.toRadians(latitude_dg), 0.);
            affichPosition(oriPos);
        }

        public void onProviderDisabled(String provider) {
        }

        public void onProviderEnabled(String provider) {
        }

        public void onStatusChanged(String provider, int status, Bundle extras) {
        }
    };

    // Callback bouton demande localisation
    public void onClickLoc(View v) {
         // majCoordonnees();
        Toast.makeText(MainActivity.this, "L'accès au GPS ne fonctionne plus sur cette appli !", Toast.LENGTH_LONG).show();
    }

    // Callback du bouton qui demande nouvelle localisation
    public void onClickNewLoc(View v) {
        View view = (LinearLayout) LinearLayout.inflate(this, R.layout.loca_dialog, null);
        edLongi = (EditText) view.findViewById(R.id.editLongi);
        edLati = (EditText) view.findViewById(R.id.editLati);
        DecimalFormatSymbols dfs = new DecimalFormatSymbols();
        dfs.setDecimalSeparator('.');
        DecimalFormat df4 = new DecimalFormat("0.0000", dfs);
        edLongi.setText(df4.format(longitude_dg));
        edLati.setText(df4.format(latitude_dg));

        AlertDialog.Builder aldb = new AlertDialog.Builder(this);
        aldb.setTitle("Nouvelle Localisation");
        aldb.setView(view); // Le layout d'édition est affiché dans l'alertDialog
        aldb.setPositiveButton("OK",
                new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int whichButton) {
                        double longi = Double.parseDouble(edLongi.getText().toString());
                        double lati = Double.parseDouble(edLati.getText().toString());
                        if (longi <= 360 && longi >= -360.) longitude_dg = longi;
                        else
                            Toast.makeText(MainActivity.this, "Longitude incorrecte", Toast.LENGTH_LONG).show();
                        if (lati <= 90 && longi >= -90.) latitude_dg = lati;
                        else
                            Toast.makeText(MainActivity.this, "Latitude incorrecte", Toast.LENGTH_LONG).show();
                        Terrien.setLocal_rdm(julSim, Math.toRadians(longitude_dg), Math.toRadians(latitude_dg), 0.);
                        oriPos = "Man";
                        affichPosition(oriPos);
                    }
                }
        );
        aldb.setNegativeButton("Annuler", null); // néant si annuler cliqué
        AlertDialog adiagLoca = aldb.create();
        adiagLoca.show();
    }

    private View.OnClickListener listenerAcQVisee = new View.OnClickListener() {
        @Override
        public void onClick(View v) {
            Intent itSel = new Intent(MainActivity.this, ViseeAcq.class);
            startActivityForResult(itSel, CODE_VISEEACQ);
        }
    };

    // Callback demande nouvelle direction de visée
    public void onClickNewVisee(View v) {
        View view = (LinearLayout) LinearLayout.inflate(this, R.layout.visee_dialog, null);
        edAzimut = (EditText) view.findViewById(R.id.editAzimut);
        edSite = (EditText) view.findViewById(R.id.editSite);
        DecimalFormatSymbols dfs = new DecimalFormatSymbols();
        dfs.setDecimalSeparator('.');
        DecimalFormat df4 = new DecimalFormat("0.0000", dfs);
        edAzimut.setText(df4.format(azimut_dg));
        edSite.setText(df4.format(site_dg));
        Button button = (Button) view.findViewById(R.id.button);
        button.setOnClickListener(listenerAcQVisee);

        AlertDialog.Builder aldb = new AlertDialog.Builder(this);
        aldb.setTitle("Nouvelle Visée");
        aldb.setView(view); // Le layout d'édition est affiché dans l'alertDialog
        aldb.setPositiveButton("OK", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int whichButton) {
                        double azi = Double.parseDouble(edAzimut.getText().toString());
                        double sit = Double.parseDouble(edSite.getText().toString());
                        if (azi <= 360 && azi >= -360.) azimut_dg = azi;
                        else
                            Toast.makeText(MainActivity.this, "Azimut incorrect", Toast.LENGTH_LONG).show();
                        if (sit <= 90 && sit >= -90.) site_dg = sit;
                        else Toast.makeText(MainActivity.this, "Site incorrect", Toast.LENGTH_LONG).show();
                        azimut_rd = (float) Math.toRadians(azimut_dg);
                        site_rd = (float) Math.toRadians(site_dg);
                        viewCiel2D.majVisee();
                        if (ciel2Dpret) viewCiel2D.invalidate();
                        else affichVisee();
                    }
                }
        );
        aldb.setNegativeButton("Annuler", null); // néant si annuler cliqué
        AlertDialog adiagLoca = aldb.create();
        adiagLoca.show();
    }


    // Callback bouton demande mise à l'heure actuelle
    public void onClickNow(View v) {
        kTimeAccel = 1.;
        buttonAR.setText("Inverse");
        julNow0 = -1;
        julSim0 = -1;// On repartira de julNow
        updateTime();
        Astro.update_eco(julSim); // permet d'appeler en mode eco autour de la date donnée
    }

    // Callback Accélération du temps
    public void onClickAcceleration(View v) {
        if (timerOn) onClickAM(null); // On arrête le timer s'il est en marche
        AlertDialog.Builder alertdialogbuilder = new AlertDialog.Builder(this);
        alertdialogbuilder.setTitle("Facteur d'accélération du temps");
        final Spinner spinner = new Spinner(alertdialogbuilder.getContext());
        ArrayList<String> list = new ArrayList<String>();
        list.add("1 seconde / seconde");
        list.add("1 minute / seconde");
        list.add("1 heure / seconde");
        list.add("1 jour / seconde");
        list.add("1 semaine / seconde");
        list.add("1 mois / seconde");
        list.add("1 année / seconde");
        list.add("10 ans / seconde");
        ArrayAdapter<String> dataAdapter = new ArrayAdapter<String>(this,
                android.R.layout.simple_spinner_item, list);
        dataAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinner.setAdapter(dataAdapter);
        double fTime = Math.abs(kTimeAccel);

        if (fTime < 2.) spinner.setSelection(0);
        else if (fTime < 61) spinner.setSelection(1);
        else if (fTime < 3601.) spinner.setSelection(2);
        else if (fTime < 86401) spinner.setSelection(3);
        else if (fTime < 604801) spinner.setSelection(4);
        else if (fTime < 2592001.) spinner.setSelection(5);
        else if (fTime < 3153601.) spinner.setSelection(6);
        else spinner.setSelection(7);

        alertdialogbuilder.setView(spinner);
        alertdialogbuilder.setPositiveButton("OK", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int whichButton) {
                int n = spinner.getSelectedItemPosition();
                int sens = kTimeAccel >= 0. ? 1 : -1;
                boolean ok = false;
                switch (spinner.getSelectedItemPosition()) {
                    case 0:
                        kTimeAccel = 1.;
                        ok = true;
                        break;
                    case 1:
                        kTimeAccel = 60.;
                        ok = true;
                        break;
                    case 2:
                        kTimeAccel = 3600.;
                        ok = true;
                        break;
                    case 3:
                        kTimeAccel = 86400.;
                        ok = true;
                        break;
                    case 4:
                        kTimeAccel = 604800.;
                        ok = true;
                        break;
                    case 5:
                        kTimeAccel = 2592000.;
                        ok = true;
                        break;
                    case 6:
                        kTimeAccel = 31536000.;
                        ok = true;
                        break;
                    case 7:
                        kTimeAccel = 315360000.;
                        ok = true;
                        break;
                }
                if (ok && sens < 0) kTimeAccel = -kTimeAccel;

                onClickAM(null); // On remet le timer en marche
            }
        });
        alertdialogbuilder.setNegativeButton("CANCEL",
                new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int whichButton) {
                        onClickAM(null); // On remet le timer en marche
                    }
                }
        );
        alertdialogbuilder.create().show();
    }

    // Routine affichage de la position fournie par le GPS ou autre
    public void affichPosition(String str) {
        if (flagSexa) {
            textViewLoc.setText("Pos(" + str + ") : Long. = " + Utils.deg2dms2(longitude_dg) + " , Lati. = " + Utils.deg2dms2(latitude_dg) /* + " , alt. = " + df0.format(altitude) */);
        } else {
            DecimalFormatSymbols dfs = new DecimalFormatSymbols();
            dfs.setDecimalSeparator('.');
            DecimalFormat df4 = new DecimalFormat("0.0000", dfs);
            textViewLoc.setText("Pos(" + str + ") : Long. = " + df4.format(longitude_dg) + " , Lati. = " + df4.format(latitude_dg) /* + " , alt. = " + df0.format(altitude) */);
        }
    }

    // Routine affichage de la direction de visée
    public void affichVisee() {
        if (flagSexa) {
            textVisee.setText("Visée    : Azim. = " + Utils.deg2dms2(azimut_dg) + " , Site = " + Utils.deg2dms2(site_dg));
        } else {
            DecimalFormatSymbols dfs = new DecimalFormatSymbols();
            dfs.setDecimalSeparator('.');
            DecimalFormat df4 = new DecimalFormat("0.0000", dfs);
            textVisee.setText("Visée    : Azim. = " + df4.format(azimut_dg) + " , Site = " + df4.format(site_dg));
        }
    }

    // Callback bouton arrêt/marche
    //------------------------------------
    public void onClickAM(View v) {

        if (timerOn) { // On arrête le timer
            myTimer.cancel();
            myTimer.purge();
            timerOn = false;
            buttonAM.setText("Marche");
        } else { // On remet en marche le timer
            // Si pa
            if (Math.abs(kTimeAccel - 1.) > 0.01 || julSim0 != julNow0) {
                julSim0 = julSim;
                julNow0 = -1;
            }
            myTimer = new Timer();
            myTimer.scheduleAtFixedRate(new MyTimerTask(), 0, period);
            timerOn = true;
            buttonAM.setText("Pause ");
        }
    }

    // Callback bouton arrêt/marche du Timer de rafraichissement
    //----------------------------------------------------------
    public void onClickSensTemps(View v) {
        if (timerOn) {
            onClickAM(null);
            kTimeAccel = -kTimeAccel;
            onClickAM(null);
        } else {
            kTimeAccel = -kTimeAccel;
            julSim0 = julSim;
            julNow0 = -1;
        }
        buttonAR.setText(kTimeAccel > 0. ? "Inverse" : "Direct");
    }

    // Callback bouton Aide
    //------------------------------------
    public void onClickHelp(View v) {
        resetChoixAffichage();
        String text =
                " Utilitaire d'astronomie populaire. Michel Llibre - 2017<br>" +
                        "<b>Ici</b> : Localisation automatique par le GPS, si disponible<br>" +
                        "<b>Loc</b> : Entrer manuellement longitude et latitude<br>" +
                        "<b>Visée</b> : Définir une direction de visée // au long coté<br>" +
                        "<b>Dec/Sex</b> : Affichage décimal <-> sexagésimal<br>" +
                        "<b>Aide</b> : Ce texte d'aide<br>" +
                        "...<br>" +
                        "<b>Now</b> : Date et heure actuelle<br>" +
                        "<b>Décalage</b> : Modifier l'époque de calcul<br>" +
                        "<b>Accel.</b> : Accélérer l'écoulement du temps<br>" +
                        "<b>Direct</b> : Le temps avancera normalement<br>" +
                        "<b>Inverse</b> : Le temps remontera vers le passé<br>" +
                        "<b>Pause</b> : Arrêter l'écoulement du temps<br>" +
                        "<b>Marche</b> : Reprise écoulement du temps<br>" +
                        "...<br>" +
                        "<b>Etoiles</b> : Sélectionner une étoiles<br>" +
                        "<b>Objets</b> : Sélectionner un objet Messier, Caldwell,...<br>" +
                        "<b>S.solaire</b> : Sélectionner planète, Soleil ou Lune<br>" +
                        "<b>Satellites</b> : Sélectionner un satellite (accès internet !). " +
                        "Pour Etoiles et Objets un clic sur le nom d'une colonne " +
                        "réordonne la liste en fonction du titre de la colonne " +
                        "la colonne distance donne la distance en degrés entre " +
                        "la direction de l'objet et la direction <i>Visée</i>. " +
                        "On peut réordonner la liste selon ce critère.<br>" +
                        "<b>Eclip2D</b> : Représentation 2D des positions des planètes " +
                        " du Soleil et de la Lune, le long de l'écliptique. " +
                        " Pour Mercure (m) et Vénus (V) leurs initiales passent de " +
                        " l'intérieur à l'extérieur suivant qu'elles sont coté Terre " +
                        " ou coté opposé par rapport au Soleil. " +
                        " Un clic sur l'affichage modifie l'origine des angles. " +
                        " L'accélération permet de prédire les époques favorables " +
                        " pour les observations.";
        textScroll.setGravity(Gravity.CENTER_VERTICAL | Gravity.LEFT);
        textScroll.setText(Html.fromHtml(text));
    } // Fin Callback bouton Aide

    // Callback bouton Sexagésimal/Décimal
    //------------------------------------
    public void onClickSexaDec(View v) {
        flagSexa = !flagSexa;
        affichPosition(oriPos);
        affichVisee();
    }

    // Callback bouton Choix satellite
    //------------------------------
    public void onClickSatels(View v) {
        Intent itSel = new Intent(this, SelSatelActivity.class);
        startActivityForResult(itSel, CODE_SELECTSATELS);
    }


    // Callback bouton Choix planète
    //------------------------------
    public void onClickSysSol(View v) {
        Intent itSel = new Intent(this, SelPlanetActivity.class);
        startActivityForResult(itSel, CODE_SELECTPLANETS);
    }

    //------------------------------------------------------------------------------
    // Callback bouton recherche étoile - Appel sous-activité sélection d'une étoile
    //------------------------------------------------------------------------------
    public void onSearchStar(View v) {
        // Direction de visée
        double uvw[] = new double[3];
        double ra_rd = Astro.topo2equaJ0_rd(julSim, Math.toRadians(azimut_dg), Math.toRadians(site_dg),
                Math.toRadians(longitude_dg), Math.toRadians(latitude_dg), uvw, true);
        double de_rd = uvw[0];
        double cd = Math.cos(de_rd);
        uvw[0] = Math.cos(ra_rd) * cd;
        uvw[1] = Math.sin(ra_rd) * cd;
        uvw[2] = Math.sin(de_rd);

        // Fabrication du tableau des étoiles à choisir, limité arbitrairement à 310
        // (pb d'allocation si trop elevé)
        int maxSizeTabStar = bigStars.length;
        if (maxSizeTabStar > 310) maxSizeTabStar = 310;
        StarParcel stars[] = new StarParcel[maxSizeTabStar];
        double dist = 0;
        double anju = (julSim - 2451545) / 365.25;
        for (int i = 0; i < maxSizeTabStar; i++) {
            Star e = bigStars[i];
            dist = Math.toDegrees(e.distanceTo(uvw, anju));
            String nom = e.nom;
            if (nom.length() > 16) nom = nom.substring(0, 16);
            stars[i] = new StarParcel(nom, Astro.Constels3[e.ixCons], e.mag, e.ad0_hd, e.de0_dd, dist);
        }

        // FABRICATION NOM DES CHAMPS A AFFICHER
        String[] nomCols = {"Nom", "Const.", "Mag.", "A.D.", "Dec.", "Dist."};
        Intent itSel = new Intent(this, SelStarActivity.class);
        itSel.putExtra("TAB_STARS", stars);
        itSel.putExtra("NOMCOLS", nomCols);
        startActivityForResult(itSel, CODE_SELECTSTARS);
    } // Fin Callback bouton recherche étoile

    //------------------------------------------------------------------------------
    // Callback bouton recherche objet Messier - Appel sous-activité sélection
    //------------------------------------------------------------------------------
    public void onSearchCelobj(View v) {
        // Direction de visée
        double uvw[] = new double[3];
        double ra_rd = Astro.topo2equaJ0_rd(julSim, Math.toRadians(azimut_dg), Math.toRadians(site_dg),
                Math.toRadians(longitude_dg), Math.toRadians(latitude_dg), uvw, true);
        double de_rd = uvw[0];
        double cd = Math.cos(de_rd);
        uvw[0] = Math.cos(ra_rd) * cd;
        uvw[1] = Math.sin(ra_rd) * cd;
        uvw[2] = Math.sin(de_rd);
        // Fabrication du tableau des objets à choisir
        CelobjParcel omess[] = new CelobjParcel[tabCelobj.length];
        double dist = 0;
        double anju = (julSim - 2451545) / 365.25;
        int ngc_ic;
        int lastindex;
        String nom;
        int notngcic = 0;
        for (int i = 0; i < tabCelobj.length; i++) {
            Celobj e = tabCelobj[i];
            dist = Math.toDegrees(e.distanceTo(uvw, anju));
            // n < 10000 c'est du NGC; 10000 < n < 20000 c'est de l'IC; > 20000 c'est autre variable
            ngc_ic = e.NGC;
            if (ngc_ic == 0) {
                if (e.IC != 0) ngc_ic = 10000 + e.IC;
                else {notngcic += 1; ngc_ic = 20000 + notngcic;}
            }

            lastindex = 14; if (lastindex > e.nom.length()) lastindex = e.nom.length();
            nom = e.nom.substring(0,lastindex);
            omess[i] = new CelobjParcel(e.id, ngc_ic, nom, Astro.Constels3[e.ixCons], e.tipe, e.mag, e.rho1, dist);
        }

        // FABRICATION NOM DES CHAMPS A AFFICHER
        String[] nomCols = {"Id.", "NgcIc", "Cons.", "type", "Mag.", "Dim.", "Dist.", "Nom"};
        Intent itSel = new Intent(this, SelCelobjActivity.class);
        itSel.putExtra("TAB_OBJETS", omess);
        itSel.putExtra("NOMCOLS", nomCols);
        startActivityForResult(itSel, CODE_SELECTCELOBJ);
    } // FIN Callback bouton recherche objet Messier


    /**
     * Retour Sous-activité
     */
    @Override
    public void onActivityResult(int req, int rep, Intent data) {
        if (req == CODE_VISEEACQ) {
            switch (rep) {
                case RESULT_OK:
                    Bundle extra = data.getExtras();
                    if (extra == null) textScroll.setText("Valeur retour inattendue !!");
                    else {
                        DecimalFormatSymbols dfs = new DecimalFormatSymbols();
                        dfs.setDecimalSeparator('.');
                        DecimalFormat df4 = new DecimalFormat("0.0000", dfs);
                        // Acquisition azimut par rapport au Nord
                        double azi_dg = extra.getDouble("cap", 0.);
                        // On le convertit par rapport au Sud
                        if (azi_dg > 0) azi_dg -= 180.; else azi_dg += 180.;
                        double sit_dg = extra.getDouble("ass", 0.);
                        edAzimut.setText(df4.format(azi_dg));
                        edSite.setText(df4.format(sit_dg));
                    }
                    break;
                case RESULT_CANCELED:
                    textScroll.setText("Retour sur cancel");
                    break;
                default:
                    textScroll.setText("Retour inopiné !");
                    break;
            }
        }
        if (req == CODE_SELECTSATELS) {
            switch (rep) {
                case RESULT_OK:
                    boolean ok = false;
                    Bundle extra = data.getExtras();
                    if (extra != null) {
                        final int noUrl = extra.getInt("NoUrl");
                        final int noSat = extra.getInt("NoSat");
                        if (noUrl >= 0 && noUrl < TwoLE.typeSats.length
                                && noSat >= 0) {
                            resetChoixAffichage();
                            Thread makeSater = new Thread() {
                                @Override
                                public void run() {
                                    satSel = new Sater(TwoLE.makeNew(TwoLE.url[noUrl], noSat));
                                    return;
                                }
                            };
                            makeSater.start();
                            while (makeSater.isAlive()) try {
                                sleep(200);
                            } catch (InterruptedException e) {
                                e.printStackTrace();
                            }

                            textScroll.setText("Sélection satellite " + satSel.name + " !");
                            if (!timerOn) myHandler.post(runnable_SyncAffich);
                        }
                    }
                    if (!ok) textScroll.setText("Valeur retour inattendue !!");
                    break;
                case RESULT_CANCELED:
                    textScroll.setText("Retour sur cancel");
                    break;
                default:
                    textScroll.setText("Retour inopiné !");
                    break;
            }
        }
        if (req == CODE_SELECTPLANETS) {
            switch (rep) {
                case RESULT_OK:
                    Bundle extra = data.getExtras();
                    int res = (extra == null ? -1 : extra.getInt("score"));
                    if (res >= 0 && res < 8) {
                        resetChoixAffichage();
                        planetSel = new Planet(res);
                        textScroll.setText("Sélection planète " + res + "!");
                        if (!timerOn) myHandler.post(runnable_SyncAffich);
                    } else if (res == 8) moonSel = new Moon(); // Cas Lune
                    else textScroll.setText("Valeur retour inattendue !!");
                    break;
                case RESULT_CANCELED:
                    textScroll.setText("Retour sur cancel");
                    break;
                default:
                    textScroll.setText("Retour inopiné !");
                    break;
            }
        }

        if (req == CODE_SELECTSTARS) {
            switch (rep) {
                case RESULT_OK:
                    Bundle extra = data.getExtras();
                    int res = (extra == null ? -1 : extra.getInt("score"));
                    if (res >= 0 && res < bigStars.length) {
                        resetChoixAffichage();
                        starSel = bigStars[res];
                        if (!timerOn) myHandler.post(runnable_SyncAffich);
                    } else textScroll.setText("Valeur retour inattendue !!");
                    break;
                case RESULT_CANCELED:
                    textScroll.setText("Retour sur cancel");
                    break;
                default:
                    textScroll.setText("Retour inopiné !");
                    break;
            }
        }
        if (req == CODE_SELECTCELOBJ) {
            switch (rep) {
                case RESULT_OK:
                    Bundle extra = data.getExtras();
                    int res = (extra == null ? -1 : extra.getInt("score"));
                    if (res >= 0 && res < tabCelobj.length) {
                        resetChoixAffichage();
                        celobjSel = tabCelobj[res];
                        if (!timerOn) myHandler.post(runnable_SyncAffich);
                    } else textScroll.setText("Valeur retour inattendue !!");
                    break;
                case RESULT_CANCELED:
                    textScroll.setText("Retour sur cancel");
                    break;
                default:
                    textScroll.setText("Retour inopiné !");
                    break;
            }
        }
    } // FIN : public void onActivityResult(int req, int rep, Intent data)

    static String lettres[] = {"m", "V", "S", "M", "J", "s", "U", "n", "L"};
    static int couleurs[] = {Color.GRAY, Color.YELLOW, Color.WHITE, Color.RED, Color.YELLOW, Color.YELLOW, Color.GREEN, Color.BLUE, Color.LTGRAY};
    static int taille[] = {2, 4, 6, 3, 4, 3, 2, 2, 6};
    static String heures[] = {"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24"};


    private class ViewSSol2D extends View {
        Paint paintSolid;
        Paint paintTrait;
        Paint paintText;
        Paint paintDash;
        int origine; // N° choix de l'origine des angles polaires
        int maxOrigines = 3;

        public ViewSSol2D(Context context) {
            super(context);

            origine = 0;

            paintSolid = new Paint();
            paintSolid.setStyle(Paint.Style.FILL);

            paintTrait = new Paint();
            paintTrait.setStyle(Paint.Style.STROKE);
            paintTrait.setColor(Color.LTGRAY);

            paintDash = new Paint();
            paintDash.setStyle(Paint.Style.STROKE);
            paintDash.setColor(Color.LTGRAY);
            float[] intervals = new float[]{10.0f, 10.0f};
            float phase = 0;
            DashPathEffect dashPathEffect =
                    new DashPathEffect(intervals, phase);
            paintDash.setPathEffect(dashPathEffect);
            setLayerType(View.LAYER_TYPE_SOFTWARE, paintDash); // pas d'accélération hard pour pointillés

            paintText = new Paint();
            paintText.setStyle(Paint.Style.FILL);
            paintText.setColor(Color.WHITE);

            setOnClickListener(listenerOriLongiSS);
        }

        @Override
        protected void onDraw(Canvas canvas) {
            super.onDraw(canvas);
            if (!ssol2Dpret) return;
            canvas.drawColor(Color.BLACK);

            int w = this.getWidth();
            int h = this.getHeight();
            int cote = h < w ? h : w;
            float un = cote / 400.f;
            if (un < 1) un = 1;
            paintText.setTextSize(12 * un);

            float cinq = 5 * un;
            float dix = 10 * un;
            float quinze = 15 * un;
            float vingt = 20 * un;
            float trente = 30 * un;

            float xo = w / 2, yo = h / 2;

            float rayOut = cote / 2 - trente;
            paintSolid.setColor(Color.BLUE);
            canvas.drawCircle(xo, yo, dix, paintSolid);
            canvas.drawText("T", xo + dix, yo + dix, paintText);
            canvas.drawCircle(xo, yo, rayOut, paintDash);

            double ang, ang0 = Math.PI / 2, ang1;
            // l'abscisse ang0 ou ang1 est retranchée
            switch (origine) {
                case 0:
                default: // Origine positionnée à +90°
                    ang0 = -Math.PI / 2;
                    ang1 = -Math.PI / 2; // aiguille 0 c'est Gamma à +90°
                    break;
                case 1: // origine Soleil positionné à  + 90°
                    ang0 = longip[2] - Math.PI / 2;
                    ang1 = -Math.PI / 2; // L'aiguille 0 c'est Gamma à + 90°
                    break;
                case 2: // origine Soleil positionné à  + 90°
                    ang0 = longip[2] - Math.PI / 2;
                    ang1 = ang0; // aiguille 0 , c'est le soleil
                    break;
            }

            float rayInt = 3 * rayOut / 4;
            float rayh = rayInt - dix;

            float ray3 = rayOut + quinze;
            float ray4 = rayOut - quinze;
            float cl, sl, x1, y1, x2, y2, x3, y3;
            // Tracé des aiguilles toutes les heures
            for (int i = 0; i < 24; i++) {
                ang = i * Math.PI / 12. - ang1;
                cl = (float) Math.cos(ang);
                sl = (float) Math.sin(ang);
                x1 = xo + rayInt * cl;
                y1 = yo - rayInt * sl;
                x2 = xo + rayOut * cl;
                y2 = yo - rayOut * sl;
                canvas.drawText(heures[i], xo + rayh * cl, yo - rayh * sl, paintText);
                canvas.drawLine(x1, y1, x2, y2, paintDash);
                if (i == 0) {

                    cl = (float) Math.cos(0 - ang0);
                    sl = (float) Math.sin(0 - ang0);
                    x2 = xo + rayOut * cl;
                    y2 = yo - rayOut * sl;

                    x3 = x2 + dix * cl;
                    y3 = y2 - dix * sl;
                    paintSolid.setColor(Color.LTGRAY);
                    canvas.drawLine(x2, y2, x3, y3, paintSolid);
                    canvas.drawLine(x3, y3, x3 - dix * cl - cinq * sl, y3 + dix * sl - cinq * cl, paintSolid);
                    canvas.drawLine(x3, y3, x3 - dix * cl + cinq * sl, y3 + dix * sl + cinq * cl, paintSolid);
                    canvas.drawText("γ", xo + ray3 * cl, yo - ray3 * sl, paintText);
                }
            }

            double rS = uvwr[2][3];
            for (int i = 0; i < 9; i++) {
                if (i == 8 && kTimeAccel > 605000.) break; // > à 1 semaine/seconde, pas de Lune
                ang = longip[i] - ang0;
                cl = (float) Math.cos(ang);
                sl = (float) Math.sin(ang);
                paintSolid.setColor(couleurs[i]);
                canvas.drawCircle(xo + rayOut * cl, yo - rayOut * sl, taille[i] * un, paintSolid);
                float r = uvwr[i][3] >= rS ? ray3 : ray4;
                canvas.drawText(lettres[i], xo + r * cl, yo - r * sl, paintText);
            }
        }

        private View.OnClickListener listenerOriLongiSS = new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                origine++;
                if (origine >= maxOrigines) origine = 0;
            }
        };

    } // FIN : private class ViewSSol2D extends View

    public enum Rendu {NEGATIF, POSITIF, REALISTE, MAX}

    ;

    private class ViewCiel2D extends View {
        final double ptCardinaux[][] = {{1., 0., 0.}, {0., 1., 0.}, {-1., 0., 0.}, {0., -1., 0.}, {0., 0., 1.}};
        final String strCardinaux[] = {"S", "E", "N", "O", "Z"};
        final float pi = (float) Math.PI;
        final static float hzo = 0.05f;
        final static float bho = hzo * (1 - hzo);
        final static float kho = (0.5f - bho) / hzo;
        int couleurCiel, couleurStars, couleurTexte;
        double magmin, magminName;
        boolean fDrawPlanetName, fDrawSat, fDrawSatName;
        boolean flagHoriz;
        boolean flagChamp;
        boolean fDrawPlanetes;
        boolean fDrawConstel;
        boolean fDrawConsName;
        boolean fShowMenu;
        final int nMenuCiel = 9;
        int wFig, hFig;
        float smallCote, bigCote;
        double cosRmax; // Cos demi-diagonale visee
        float wmenu, hmenu;
        Rendu rendu;
        float kmulSL;
        float unPix, deuxPix, cinqPix, dixPix;

        // Angle de visée
        float alfamax, as2;
        double cosAs2;
        float angSol, angVis;
        boolean interVisOk;
        float factor, ix0, iy0;
        double ascDr0, dec0; // coordonnées du centre de visée

        // Position et direction de visée
        float RayHoriz, AltHoriz;
        float fas2, fRay, fApRay, fAmRay;

        double m3_AP[][] = new double[3][3];
        double m3_CP[][] = new double[3][3];

        // Pour eviter les news dans le draw
        float xx[] = new float[1], yy[] = new float[1];
        float xS[] = new float[1], yS[] = new float[1];
        float xL[] = new float[1], yL[] = new float[1];
        float hh[] = new float[1], hS[] = new float[1], hL[] = new float[1];
        double uvw[] = new double[3];
        double v3_a[] = new double[3];
        double v3_g[] = new double[3];
        double v3_p[] = new double[3];

        //CosDir des Constellations dans celeste J2000
        double Constels_uCS[][] = new double[Astro.Constels3.length][3];

        Path pathVisee;
        Paint painter;
        Paint painterText;
        Paint paintDashBlue;
        String strState;
        long tmsState;

        int lastStar = -1; // index dernière étoile dedans

        public ViewCiel2D(Context context) {
            super(context);
            // Quelques init
            // Initialisations visée stellaire
            alfamax = 120 * pi / 180; // Angle max de la visée (0 à PI)
            kmulSL = 1; // Toujours a 1 pour le moment
            magmin = 4.5;
            magminName = 1.0;
            fDrawConstel = true;
            fDrawConsName = false;
            fDrawPlanetes = true;
            fDrawPlanetName = true;
            fDrawSat = false;
            fDrawSatName = true;
            flagChamp = false;
            flagHoriz = true;
            rendu = Rendu.REALISTE;  // Couleur de fond
            fShowMenu = true;

            //CosDir des Constellations dans celeste J2000
            double cb;
            for (int i = 0; i < Astro.Constels3.length; i++)
            {
                cb = Math.cos(Astro.constelDec_rd[i]);
                Constels_uCS[i][0] = Math.cos(Astro.constelAD_rd[i])*cb;
                Constels_uCS[i][1] = Math.sin(Astro.constelAD_rd[i])*cb;
                Constels_uCS[i][2] = Math.sin(Astro.constelDec_rd[i]);
            }

            majVisee();
            majColors();

            painter = new Paint();
            painter.setStyle(Paint.Style.FILL_AND_STROKE);
            painter.setStrokeCap(Paint.Cap.ROUND);

            painterText = new Paint();
            painterText.setStyle(Paint.Style.FILL_AND_STROKE);

            paintDashBlue = new Paint();
            paintDashBlue.setStyle(Paint.Style.STROKE);
            paintDashBlue.setColor(Color.BLUE);
            float[] intervals = new float[]{10.0f, 10.0f};
            float phase = 0;
            DashPathEffect dashPathEffect =
                    new DashPathEffect(intervals, phase);
            paintDashBlue.setPathEffect(dashPathEffect);
            setLayerType(View.LAYER_TYPE_SOFTWARE, paintDashBlue);// pas d'accélération hard pour pointillés

            pathVisee = new Path();

            // Ajout d'un click Listener sur l'écran
            this.setOnClickListener(listener1Ciel2D);

            // On ajoute un listener pour le déplacement du doigt sur l'écran
            this.setOnTouchListener(MyOnTouchListener);
            touchState = NEANT;
        }

        void majVisee() {
            float pi2s4 = pi * pi / 4;
            float sit2 = site_rd * site_rd;
            as2 = alfamax / 2; // demi-angle de vue
            cosAs2 = Math.cos(as2);
            updateFactors();

            // Matrice de projection fonction d'azimut et site
            R3.asiTom3(m3_AP, azimut_rd, site_rd);

            // Horizon et champ de vue
            RayHoriz = 0.5f * (pi2s4 + sit2) /  Math.abs(site_rd);
            AltHoriz = 0.5f * (pi2s4 - sit2) / site_rd;
            float a2s4 = as2 * as2;
            float ymath = -0.5f * (pi2s4 - a2s4) / AltHoriz;
            if (a2s4 - ymath * ymath > 0.) { // Existence inter cercle vue et horizon
                interVisOk = true;
                angVis = (float) (Math.asin(ymath / as2) * 180. / Math.PI);
                angSol = (float) (Math.asin((ymath - AltHoriz) / RayHoriz) * 180. / Math.PI);
            } else {
                interVisOk = false;
                angSol = 0.f;
            }

            strState = "Azi = " + Utils.deg2dms2(azimut_dg) +
                    " Sit = " + Utils.deg2dms2(site_dg) +
                    " Fov = " + Utils.deg2dms(Math.toDegrees(alfamax));
            tmsState = System.nanoTime();
        }

        void majColors() {
            if (rendu == Rendu.NEGATIF) {
                couleurCiel = Color.WHITE;
                couleurStars = Color.BLACK;
            } else if (rendu == Rendu.POSITIF || rendu == Rendu.REALISTE) {
                couleurCiel = Color.BLACK; // est recalculé si Rendu.REALISTE
                couleurStars = Color.WHITE; // etoiles blanches disparaissent de jour
            }
            couleurTexte = couleurStars; // est recalculé si Rendu.REALISTE
            strState = "Rendu = " + rendu.ordinal();
            tmsState = System.nanoTime();
        }

        /**
         * Projection direction unitaire/RepèreLocal dans l'écran
         * Renvoi les composantes ix, iy dans le repère plan et
         * le hauteur au dessus du sol (sinus du site)
         */
        boolean uRaToxy(float[] ix, float[] iy, float[] h, float ix0, float iy0, float factor, double[] v3_a) {
            double alpha, rho;
            h[0] = (float) v3_a[2];
            // Projection sur le plan orthogonal à la visée
            R3.matvec(v3_p, m3_AP, v3_a);
            alpha = Utils.acos(-v3_p[2]);
            // Facteur de projection sphérique sur l'écran
            rho = factor * alpha / Math.hypot(v3_p[0], v3_p[1]);
            // Projection sur l'écran de l'étoile
            ix[0] = ix0 + (float) (rho * v3_p[0]);
            iy[0] = iy0 - (float) (rho * v3_p[1]);
            if (flagChamp && alpha > 1.3*as2) return false; // Direction hors du cone de vue
            return true;
        }


        /**
         * Projection position objet/RepèreGreenwich dans l'écran
         * Renvoi les composantes ix, iy dans le repère plan et
         * le hauteur au dessus du sol (sinus du site)
         */

        boolean uRgToxy(float[] ix, float[] iy, float[] h, float ix0, float iy0, float factor, double[] v3_GS)
        {
            double alpha, rho;
            double v, dist = 0., v3_AS[] = new double[3];
            // Segment station-Satellite dans Rg
            for (int i = 0; i < 3; i++) {
                v = v3_GS[i] - Terrien.v3_GA[i];
                v3_AS[i] = v;
                dist += v*v;
            }
            dist = Math.sqrt(dist);
            for (int i = 0; i < 3; i++) v3_AS[i] /= dist;
            // Le meme dans Ra
            R3.matvec(v3_a, Terrien.m3_GA, v3_AS);
            h[0] = (float) v3_a[2];
            // Projection dans le repère du viseur
            R3.matvec(v3_p, m3_AP, v3_a);
            alpha = Utils.acos(-v3_p[2]); // angle avec l'axe de visée
            // Facteur de projection sphérique sur l'écran rho = f *
            rho = factor * alpha / Math.hypot(v3_p[0], v3_p[1]);
            // Projection sur l'écran de l'étoile
            ix[0] = ix0 + (float) (rho * v3_p[0]);
            iy[0] = iy0 - (float) (rho * v3_p[1]);
            //    if (flagHoriz && v3_a[2] < 0.) return false; // Direction sous l'horizon
            if (flagChamp && alpha > 1.3*as2) return false; // Direction hors du cone de vue
            return true;
        }


        /**
         * Projection direction unitaire ou position/Repère Céleste dans l'écran
         * Renvoi les composantes ix, iy dans le repère plan et la hauteur au dessus du sol (sinus du site)
         * dist  :
         * - <= 0, si direction d'un objet très éloigné non influencé par la position de l'observateur
         * - > 0 si direction proche pour prise en compte de la localisation de l'observateur sur Terre.
         * dans ce cas uvec[3] contient la distance en mètre de l'objet
         */
        boolean uRcToxy(float[] ix, float[] iy, float[] h, float ix0, float iy0, float factor, double[] uvec, double dist)
        {
            double alpha, rho;

            // Projection dans repère Local
            if (dist > 0.) // Si Vecteur position proche, prise en compte situation observateur
            {
                for (int i = 0; i < 3; i++) v3_g[i] = uvec[i] * dist;
                R3.matvec(v3_g, Terrien.m3_CG, v3_g); // Coordonnées dans Greenwich
                // AL = TL - TA
                double lal = 0.;
                for (int i = 0; i < 3; i++) {
                    v3_g[i] = v3_g[i] - Terrien.v3_GA[i]; // Coordonnées / Point Local
                    lal += v3_g[i] * v3_g[i];
                }
                lal = Math.sqrt(lal);
                for (int i = 0; i < 3; i++) v3_g[i] /= lal; // Direction
                // Puis dans local
                R3.matvec(v3_a, Terrien.m3_GA, v3_g); // Proj dans local
            }
            // projection directe dans local
            else R3.matvec(v3_a, Terrien.m3_CA, uvec);

            h[0] = (float) v3_a[2];
            // Projection sur le plan orthogonal à la visée
            R3.matvec(v3_p, m3_AP, v3_a);
            alpha = Utils.acos(-v3_p[2]);
            // Facteur de projection sphérique sur l'écran
            rho = factor * alpha / Math.hypot(v3_p[0], v3_p[1]);
            // Projection sur l'écran de l'étoile
            ix[0] = ix0 + (float) (rho * v3_p[0]);
            iy[0] = iy0 - (float) (rho * v3_p[1]);
            //    if (flagHoriz && v3_a[2] < 0.) return false; // Direction sous l'horizon
            if (flagChamp && alpha > 1.3*as2) return false; // Direction hors du cone de vue
            return true;
        }

        // Passage coordonnées écran -> coordonnées équatoriales
        void xy2uRc(float px, float  py, float ix0, float iy0, float factor, double[] v3_c)
        {
            double ix, iy;
            double fa2, x2pY2;
            double cosalf, rho;
            ix = px - ix0; iy = iy0 - py;
            fa2 = ix*ix + iy*iy;
            cosalf = Math.cos(Math.sqrt(fa2)/factor);
            // Calcul v3_a mis dans v3_c
            v3_c[2] = - cosalf;
            x2pY2 = 1. - cosalf*cosalf;
            rho = Math.sqrt(fa2/x2pY2);
            v3_c[0] = ix/rho;
            v3_c[1] = iy/rho;
            R3.madvec(v3_c, m3_CP, v3_c);
        }

        /* Taille pîxels en fonstion de la magnitude */
        float mag2siz(float x) /*{ return 350./((x+11.)*(x+11.)); }*/ {
            if (x < 0) return 2.5f;
            if (x > 8) return 4 / x;
            return 2.5f - x / 4;
        }

        @Override
        protected void onSizeChanged(int w, int h, int oldw, int oldh) {
            super.onSizeChanged(w, h, oldw, oldh);

            wFig = w;
            hFig = h;
            updateSizes();
        }

        void updateSizes()
        {
            if(hFig < wFig) {smallCote = hFig; bigCote = wFig;}
            {smallCote = wFig; bigCote = hFig;}
            unPix = smallCote / 400.f;
            if (unPix < 1) unPix = 1;
            wmenu = ((float) wFig)/nMenuCiel;
            hmenu = wmenu; if (hmenu > 36*unPix) hmenu = 36*unPix;
            deuxPix = 2* unPix;
            cinqPix = 5 * unPix;
            dixPix = 10 * unPix;
            painterText.setTextSize(12 * unPix);
            updateFactors();
        }

        void updateFactors()
        {
            cosRmax = cosAs2*Math.cos(as2*bigCote/smallCote);

            // Facteur de conversion unités projetées en pixels globalement équivalent à une focale
            // factor * angle => nb de pixels
            factor = smallCote / alfamax;
            fas2 = factor * as2;
        }


        @Override
        protected void onDraw(Canvas canvas) {
            super.onDraw(canvas);
            if (!ciel2Dpret) return;
            // Paramètre horizon
            fRay = factor * RayHoriz;
            fApRay = factor * (RayHoriz + AltHoriz);
            fAmRay = factor * (RayHoriz - AltHoriz);

            // Origine centre en X et centre en Y
            ix0 = wFig / 2.f;
            iy0 = hFig / 2.f;

            // Matrice de projection Rc (équatorial) -> Rp ( projection visée)
            // Non utilisée en direct car  nécessité de passer par l'intermédiaire
            // de Ra pour avoir la hauteur / sol,
            // mais utilisée en inverse pour retrouver les coordonnées célestes
            R3.madmad(m3_CP, Terrien.m3_CA, m3_CP);

            // Traitement Soleil pour calcul hauteurSol pour la luminosité ambiante
            boolean solInCone = false;
            float rxsol = kmulSL * factor * ((float) (Astro.raySol / Astro.UA));
            if (rxsol < 5) rxsol = 5;

            // Présence/absence Soleil dans cone de visée
            solInCone = uRcToxy(xS, yS, hS, ix0, iy0, factor, uvwr[2], -1.);
            float hauteurSol = hS[0]; // Sinus du site du Soleil

            // Mise a jour couleur traces si prise en compte hauteur soleil
            if (rendu == Rendu.REALISTE) {
                float val;
                if (hauteurSol < -hzo) val = hzo * (hauteurSol + 1);
                else if (hauteurSol > hzo) val = 1 + hzo * (hauteurSol - 1);
                else val = bho + kho * (hauteurSol + hzo);
                int gris = (int) (255 * val);
                if (gris < 0) gris = 0;
                if (gris > 255) gris = 255;
                if (gris < 128) couleurTexte = Color.WHITE;
                else couleurTexte = Color.BLACK;
                int couleurGrise = 0xff << 24 | (gris & 0xff) << 16 | (gris & 0xff) << 8 | (gris & 0xff);
                couleurCiel = couleurGrise;
            }

            painterText.setColor(couleurTexte);
            if (false ) { // Version simple sans aucun cache
                painter.setColor(couleurStars);
                canvas.drawColor(couleurCiel);
            }
            else {// Mise en place de caches pour le sol et l'angle de vue
                pathVisee.reset();
                if (flagChamp && flagHoriz) {
                    if (interVisOk) // existe intersection
                    {
                        // Attention les angles sont comptés positif dans le sens horaire !!!!!!!!!!
                        // avec origine axe horizontal vers la droite.
                        pathVisee.arcTo(new RectF(ix0 - fas2, iy0 - fas2, ix0 + fas2, iy0 + fas2),
                                180 + angVis, 180 - 2 * angVis, true);
                        if (site_rd > 0) {
                            pathVisee.arcTo(new RectF(ix0 - fRay, iy0 - fApRay, ix0 + fRay, iy0 + fAmRay),
                                    -angSol, 180 + 2 * angSol, false);
                        } else {
                            pathVisee.arcTo(new RectF(ix0 - fRay, iy0 - fApRay, ix0 + fRay, iy0 + fAmRay),
                                    180 + angSol, 180 - 2 * angSol, true);
                        }
                    } else // Si pas d'intersection, seul le Champ est pris en compte
                    {
                        pathVisee.addOval(new RectF(ix0 - fas2, iy0 - fas2, ix0 + fas2, iy0 + fas2), Path.Direction.CW);
                    }
                } else if (flagChamp)
                    pathVisee.addOval(new RectF(ix0 - fas2, iy0 - fas2, ix0 + fas2, iy0 + fas2), Path.Direction.CW);
                else if (flagHoriz) {
                    if (site_rd > 0)
                        pathVisee.addOval(new RectF(ix0 - fRay, iy0 - fApRay, ix0 + fRay, iy0 + fAmRay), Path.Direction.CW);
                    else
                        pathVisee.addOval(new RectF(ix0 - fRay, iy0 - fApRay, ix0 + fRay, iy0 + fAmRay), Path.Direction.CW);
                } else pathVisee.addRect(0, 0, wFig, hFig, Path.Direction.CW);
                painter.setColor(couleurCiel);
                painter.setStyle(Paint.Style.FILL);
                canvas.drawColor(couleurStars);
                canvas.drawPath(pathVisee, painter);
                painter.setColor(couleurStars);
                painter.setStyle(Paint.Style.FILL_AND_STROKE);
            }

            // Dessin ligne de l'horizon si pas déja présent
            if (!flagHoriz){
                canvas.drawArc(new RectF(ix0 - fRay, iy0 - fApRay, ix0 + fRay, iy0 + fAmRay)
                        , site_rd > 0 ? 0 : 180, 180, false, paintDashBlue);
            }

            // Dessin des points cardinaux
            for (int npt = 0; npt < 5; npt++)
                if (uRaToxy(xx, yy, hh, ix0, iy0, factor, ptCardinaux[npt])) {
                    canvas.drawLine(xx[0] - cinqPix, yy[0], xx[0] + cinqPix, yy[0], painter);
                    canvas.drawLine(xx[0], yy[0] - cinqPix, xx[0], yy[0] + cinqPix, painter);
                    canvas.drawText(strCardinaux[npt], xx[0] + cinqPix, yy[0] - dixPix, painterText);
                }

            // Dessin du soleil
            if (fDrawPlanetes && solInCone) {
                float r = rxsol;
                if (r < cinqPix) r = cinqPix;
                canvas.drawOval(new RectF(xS[0] - r, yS[0] - r, xS[0] + r, yS[0] + r), painter);
                if (fDrawPlanetName)
                    canvas.drawText("SOLEIL", xS[0] + r + cinqPix, yS[0] - r - cinqPix, painterText);
            }

            // Dessin de la Lune
            boolean luneInCone = false;
            float rxLune = factor * kmulSL * (float) (Moon.rayLune / Moon.distTL);
            if (rxLune < cinqPix) rxLune = cinqPix;
            // Présence/absence Lune dans cone de visée
            luneInCone = uRcToxy(xL, yL, hL, ix0, iy0, factor, uvwr[8], uvwr[8][3]);

            if (luneInCone) {
                canvas.drawOval(new RectF(xL[0] - rxLune, yL[0] - rxLune, xL[0] + rxLune, yL[0] + rxLune), painter);
                canvas.drawText("LUNE", xL[0] + rxLune + cinqPix, yL[0] - rxLune - cinqPix, painterText);
            }


            // Dessin des étoiles et satellites systématique si rendu == POSITIF ou NEGATIF
            // Si clarté == REALISTE les étoiles et les satellites ne sont vus que si le Soleil est couché
            lastStar = -1;
            if (rendu != Rendu.REALISTE || hauteurSol < 0.) {
                float taille = painter.getStrokeWidth();
                // Initialise toutes les étoiles et constellations hors ecran
                boolean constelPresente[] = new boolean[Astro.Constels3.length];
                if (fDrawConstel) for (int i = 0; i < bigStars.length; i++) bigStars[i].fInScreen = false;
                if (fDrawConsName) for (int i = 0; i < Astro.Constels3.length; i++) constelPresente[i] = false;

                // Dessin d'un point pour les étoiles
                for (int i = 0; i < bigStars.length; i++)
                {
                    // Tableau présence étoile des constellations dans l'écran
                    Star e = bigStars[i];
                    if (!uRcToxy(xx, yy, hh, ix0, iy0, factor, e.uCS, -1.)) continue;
                    // L'étoile est approximativement dedans.
                    lastStar = i; // Dernière étoile dans le voisinage de la visée
                    e.px = xx[0]; e.py = yy[0];
                    // Test si l'étoile est effectivement dedans
                    if (e.px >= 0 && e.px <= wFig && e.py >= 0 && e.py <= hFig) {
                        e.fInScreen = true;
                    }
                    // Dessin trait des constellations
                    boolean untrai = false;
                    if (e.fInScreen && fDrawConstel && e.nbLiens > 0) {
                        for (int ns = 0; ns < e.nbLiens; ns++) {
                            Star s = bigStars[e.liens[ns]];
                            boolean ok1 = true, ok2 = true;
                            if (s.fInScreen) {
                                untrai = true;
                                canvas.drawLine(e.px, e.py, s.px, s.py, painter);
                            }
                        }
                    }
                    if (untrai) constelPresente[e.ixCons] = true;
                    if (e.mag > magmin) continue;
                    canvas.drawCircle(xx[0], yy[0], unPix * mag2siz((float) e.mag) / 2, painter);
                    if (e.mag < magminName && e.nom.length() > 0) {
                        canvas.drawText(e.nom, xx[0] + cinqPix, yy[0] - cinqPix, painterText);
                    }
                }
                painter.setStrokeWidth(taille);
                // NOM DES CONSTELLATION
                if (fDrawConsName)
                {
                    for (int k = 0; k < Astro.Constels3.length; k++)
                    {
                        if (!constelPresente[k]) continue; // Aucune trait de cette constellation
                        if (!uRcToxy(xx, yy, hh, ix0, iy0, factor, Constels_uCS[k], -1.)) continue;
                        canvas.drawText(Astro.nomConstelsFrCourt[k], xx[0], yy[0], painterText);
                    }
                }
                // Dessin Satellite
                if (fDrawSat && satSel != null && uRgToxy(xx, yy, hh, ix0, iy0, factor, satSel.v3_TS_g))
                {
                    painter.setStyle(Paint.Style.STROKE);
                    canvas.drawRect(xx[0]-deuxPix, yy[0]-deuxPix, xx[0]+deuxPix, yy[0]+deuxPix, painter);
                    painter.setStyle(Paint.Style.FILL_AND_STROKE);
                    if (fDrawSatName)
                        canvas.drawText(satSel.name, xx[0]+cinqPix, yy[0]-cinqPix, painterText);
                }
            }

            if (fDrawPlanetes) {
                // Tracé des planètes
                for (int k = 0; k < 8; k++) {
                    if (k == 2) continue;
                    if (!uRcToxy(xx, yy, hh, ix0, iy0, factor, uvwr[k], -1.)) continue;
                    canvas.drawCircle(xx[0], yy[0], unPix * mag2siz((float) Planet.moys[k]), painter);
                    if (fDrawPlanetName)
                        canvas.drawText(Astro.nomPla[k], xx[0] + cinqPix, yy[0] - cinqPix, painterText);
                }
            }
            if (fShowMenu) {
                painter.setColor(couleurCiel);
                canvas.drawRect(0,0,wFig,2*hmenu,painter);
                painter.setColor(couleurTexte);
                float ht = 2*hmenu/3;
                float ec2 = (wmenu - ht)/2, ec1 = ec2/2;
                canvas.drawLine(0, hmenu,  wFig, hmenu, painter);
                canvas.drawLine(0, 2*hmenu,  wFig, 2*hmenu, painter);
                painter.setTextSize(ht);
                for (int i = 1; i < nMenuCiel-2; i++)
                {
                    canvas.drawLine(i * wmenu, 0, i * wmenu, 2*hmenu, painter);
                }
                for (int i = nMenuCiel-2; i < nMenuCiel; i++)
                {
                    canvas.drawLine(i * wmenu, hmenu, i * wmenu, 2*hmenu, painter);
                }
                canvas.drawText("E+", 0* wmenu + ec1, ht + deuxPix, painter);
                canvas.drawText("E-", 1* wmenu + ec1, ht + deuxPix, painter);
                canvas.drawText("C", 2* wmenu + ec2, ht + deuxPix, painter);
                canvas.drawText("P", 3* wmenu + ec2, ht + deuxPix, painter);
                canvas.drawText("S", 4* wmenu + ec2, ht + deuxPix, painter);
                canvas.drawText("O", 5* wmenu + ec2, ht + deuxPix, painter);
                canvas.drawText("I/O", 7* wmenu + ec1, ht + deuxPix, painter);
                canvas.drawText("n+", 0* wmenu + ec1, hmenu + ht + deuxPix, painter);
                canvas.drawText("n-", 1* wmenu + ec1, hmenu + ht + deuxPix, painter);
                canvas.drawText("n", 2* wmenu + ec2, hmenu + ht + deuxPix, painter);
                canvas.drawText("n", 3* wmenu + ec2, hmenu + ht + deuxPix, painter);
                canvas.drawText("n", 4* wmenu + ec2, hmenu + ht + deuxPix, painter);
                canvas.drawText("H", 5* wmenu + ec2, hmenu + ht + deuxPix, painter);
                canvas.drawText("N", 6* wmenu + ec2, hmenu + ht + deuxPix, painter);
                canvas.drawText("B", 7* wmenu + ec2, hmenu + ht + deuxPix, painter);
                canvas.drawText("G", 8* wmenu + ec2, hmenu + ht + deuxPix, painter);
            }
            // Ecriture des lignes d'état
            if (System.nanoTime() - tmsState < 1500000000L)
            {
                canvas.drawText(strState, unPix, 12*unPix + (fShowMenu ? 2*hmenu : 0), painterText);
            }

        }

        //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        private View.OnClickListener listener1Ciel2D = new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                boolean doUpdate = false;
                int noMenu = ((int) (xTouchOri /wmenu)) + nMenuCiel*((int) (yTouchOri/hmenu));
                if (fShowMenu && yTouchOri < 2*hmenu) { // Clic dans le menu actif
                    doUpdate = true;
                    switch (noMenu) {
                        case 0: // Augmente le nombre d'étoiles
                            if (magmin > 4.4 && magmin < 4.9) magmin += 0.5/3.;
                            else magmin += 0.5;
                            if(magmin > 8.) magmin = 8.;
                            strState = "StarMagMin = " + magmin;
                            break;
                        case 1: // Augmente le nombre d'étoiles
                            if (magmin > 4.6 && magmin < 5.1) magmin -= 0.5/3.;
                            else magmin -= 0.5;
                            if(magmin < -2) magmin = -2;
                            strState = "StarMagMin = " + magmin;
                            break;
                        case 9: // Augmente le nombre d'étoiles
                            magminName += 0.5; if(magminName > 5.5) magminName = 5.5;
                            strState = "NomStarMagMin = " + magminName;
                            break;
                        case 10: // Augmente le nombre d'étoiles
                            magminName -= 0.5; if(magminName < -2) magminName = -2;
                            strState = "NomStarMagMin = " + magminName;
                            break;
                        case 2:
                            fDrawConstel = !fDrawConstel;
                            strState = "Tracé des constellations = " + fDrawConstel;
                            break;
                        case 11:
                            fDrawConsName = !fDrawConsName;
                            strState = "Nom des constellations = " + fDrawConsName;
                            break;
                        case 3:
                            fDrawPlanetes = !fDrawPlanetes;
                            strState = "Présence des planètes = " + fDrawPlanetes;
                            break;
                        case 12:
                            fDrawPlanetName = !fDrawPlanetName;
                            strState = "Nom des planètes = " + fDrawPlanetName;
                            break;
                        case 4:
                            fDrawSat = !fDrawSat;
                            strState = "Présence des satellites = " + fDrawSat;
                            break;
                        case 13:
                            fDrawSatName = !fDrawSatName;
                            strState = "Nom des satellites = " + fDrawSatName;
                            break;
                        case 5:
                            flagChamp = !flagChamp;
                            strState = "Champ de vue = " + flagChamp;
                            break;
                        case 14:
                            flagHoriz = !flagHoriz;
                            strState = "Présence sol = " + flagHoriz;
                            break;
                        case 6:
                        case 7 :
                        case 8 :
                            fShowMenu = false; break;
                        case 15: rendu = Rendu.POSITIF;  strState = "Rendu ciel blanc, étoiles noires";  majColors(); break;
                        case 16: rendu = Rendu.NEGATIF;  strState = "Rendu ciel blanc, étoiles noires";  majColors(); break;
                        case 17: rendu = Rendu.REALISTE; strState = "Rendu réaliste";  majColors(); break;
                        default :
                            doUpdate = false; break;
                    }
                }
                // Clic pour activer le menu
                else
                {
                    if (!fShowMenu && yTouchOri < 2*hmenu && noMenu >= 6 && noMenu <= 8) {fShowMenu = true; doUpdate = true;}
                    else
                    { // Clic pour sélectionner une étoile
                        float dx, dy;
                        double dist, distmin = wFig + hFig;
                        int imin = -1;
                        for (int i = 0; i <= lastStar; i++) {
                            Star e = bigStars[i];
                            if (!e.fInScreen) continue;
                            dx = xTouchOri - e.px;
                            dy = yTouchOri - e.py;
                            dist = Math.hypot(xTouchOri - e.px, yTouchOri - e.py);
                            if (dist < distmin) {
                                distmin = dist;
                                imin = i;
                            }
                        }
                        if (imin >=0) {
                            strState = "Clic au voisinage de " + bigStars[imin].nom ;
                            tmsState = System.nanoTime();
                            resetChoixAffichage();
                            starSel = bigStars[imin];
                        }
                    }
                }

                if (doUpdate) {
                    tmsState = System.nanoTime();
                    if (!timerOn) viewCiel2D.invalidate();
                }
            }
        };

        int touchState; // etat de l'action entreprise par l'utilisateur avec ses doigts
        final int NEANT = 0; // Aucune action
        final int MOVE = 2; // L'usager fait une glissade
        boolean flagPinch; // un deuxième doigt est appuyé
        boolean flagTrans; // Uniquement translation
        int iTouch; // dernier doigt appuyé
        long seuilTime = 200;
        float distOri, alfaOri;
        float xTouchOri, yTouchOri, aziOri, sitOri;

        // Routine de traitement des actions des doigts sur l'ecran
        OnTouchListener MyOnTouchListener = new OnTouchListener() {
            @Override
            public boolean onTouch(View view, MotionEvent event) {
                float deltaX, deltaY, dist;
                boolean flagUpdate = false;
                switch (event.getAction() & MotionEvent.ACTION_MASK) {
                    case MotionEvent.ACTION_DOWN:
                        // Premier appui. On initialise la capture
                        xTouchOri = event.getX(); aziOri = azimut_rd;
                        yTouchOri = event.getY(); sitOri = site_rd;
                        iTouch = 0; // 1er doigt
                        flagPinch = false;
                        flagTrans = true;
                        break;
                    case MotionEvent.ACTION_POINTER_DOWN:
                        //Un deuxieme appui est detecte : c'est du PINCH
                        iTouch = event.getActionIndex();
                        //ecart initial entre les deux doigts
                        deltaX = event.getX(0) - event.getX(1);
                        deltaY = event.getY(0) - event.getY(1);
                        distOri = (float) Math.hypot(deltaX, deltaY);
                        alfaOri = alfamax;
                        flagPinch = true;
                        break;
                    case MotionEvent.ACTION_MOVE:
                        if (event.getEventTime() - event.getDownTime() > seuilTime)
                        {
                            if (flagPinch) // on modifie alfamax
                            {
                                deltaX = event.getX(0) - event.getX(1);
                                deltaY = event.getY(0) - event.getY(1);
                                dist = (float) Math.hypot(deltaX, deltaY);
                                alfamax = alfaOri * distOri / dist;
                                if (alfamax < 0.02f) alfamax = 0.02f;
                                if (alfamax > 3.1415926535f) alfamax = 3.1415926535f;
                            } else if (flagTrans) {
                                azimut_rd = aziOri + alfamax * (event.getX() - xTouchOri) / wFig;
                                azimut_rd = (float) Utils.mod2(azimut_rd, Math.PI * 8.);
                                site_rd = sitOri + alfamax * (event.getY() - yTouchOri) / hFig;
                                if (site_rd > Math.PI / 2.) site_rd = (float) (Math.PI / 2.);
                                if (site_rd < -Math.PI / 2.) site_rd = (float) (-Math.PI / 2.);
                                azimut_dg = Math.toDegrees(azimut_rd);
                                site_dg = Math.toDegrees(site_rd);
                            }
                            touchState = MOVE;
                            flagUpdate = true;
                            majVisee();
                        }
                        break;
                    case MotionEvent.ACTION_POINTER_UP:
                    case MotionEvent.ACTION_UP:
                        touchState = NEANT; // Raz action en cours
                        flagPinch = false;
                        flagTrans = false;
                        // Si Appui bref on considere que c'était un clic, on appelle son listener
                        if (event.getEventTime() - event.getDownTime() <= seuilTime)
                            listener1Ciel2D.onClick(view);
                        break;
                }
                if(!timerOn && flagUpdate) { viewCiel2D.invalidate();}
                return true;
            }
        };

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    } // FIN : private class ViewSSol2D extends View


} // FIN : public class MainActivity extends Activity

/**
 * Classe conteneur implémentant l'interface Parcelable créée pour faciliter le transfert de certains champs
 * des étoiles à la routine de sélection. En effet les Intents ne savent transférer que des tableaux
 * de types simples, des tableaux de String et des tableaux de classes implémentant l'interface
 * Parcelable, et encore, il faut caster individuellement tous les éléments du tableau dans le
 * type de la classe à la réception (c'est pas automatique et ça ne peut pas se faire globalement).
 */
class StarParcel implements Parcelable {
    int n; // index initial rempli par le sélecteur pour retrouver le rang initial
    String nom;
    String constel;
    double mag;
    double asd;
    double dec;
    double dist; // distance à la direction visée
    String all; // Rempli par le sélecteur pour l'affichage

    public StarParcel(String name, String c, double m, double a, double b, double d) {
        nom = name;
        constel = c;
        mag = m;
        asd = a;
        dec = b;
        dist = d;
    }

    public int describeContents() {
        return 0;
    }

    public void writeToParcel(Parcel dest, int flags) {
        dest.writeInt(n);
        dest.writeString(nom);
        dest.writeString(constel);
        dest.writeDouble(mag);
        dest.writeDouble(asd);
        dest.writeDouble(dec);
        dest.writeDouble(dist);
        dest.writeString(all);
    }

    public static final Parcelable.Creator<StarParcel> CREATOR = new Parcelable.Creator<StarParcel>() {
        public StarParcel createFromParcel(Parcel source) {
            return new StarParcel(source);
        }

        public StarParcel[] newArray(int size) {
            return new StarParcel[size];
        }
    };

    private StarParcel(Parcel in) {
        n = in.readInt();
        nom = in.readString();
        constel = in.readString();
        mag = in.readDouble();
        asd = in.readDouble();
        dec = in.readDouble();
        dist = in.readDouble();
        all = in.readString();
    }
} // FIN : class StarParcel implements Parcelable


/**
 * Classe conteneur implémentant l'interface Parcelable créée pour faciliter le transfert de certains champs
 * des objets Messier et CaldWelle à la routine de sélection. En effet les Intents ne savent transférer que
 * des tableaux de types simples, des tableaux de String et des tableaux de classes implémentant l'interface
 * Parcelable, et encore, il faut caster individuellement tous les éléments du tableau dans le
 * type de la classe à la réception (c'est pas automatique et ça ne peut pas se faire globalement).
 */
class CelobjParcel implements Parcelable {
    int n; // index initial rempli par le sélecteur pour retrouver le rang initial
    String id;
    int ngc_ic;
    String constel;
    String tipe;
    double mag;
    double dim;
    double dist;  // distance à la direction visée
    String nom;
    String all; // Rempli par le sélecteur pour l'affichage

    public CelobjParcel(String idt, int ni, String name, String c, String tip, double m, double d, double di) {
        id = idt;
        ngc_ic = ni;
        constel = c;
        tipe = tip;
        mag = m;
        dim = d;
        dist = di;
        nom = name;
    }

    public int describeContents() {
        return 0;
    }

    public void writeToParcel(Parcel dest, int flags) {
        dest.writeInt(n);
        dest.writeString(id);
        dest.writeInt(ngc_ic);
        dest.writeString(constel);
        dest.writeString(tipe);
        dest.writeDouble(mag);
        dest.writeDouble(dim);
        dest.writeDouble(dist);
        dest.writeString(nom);
        dest.writeString(all);
    }

    public static final Parcelable.Creator<CelobjParcel> CREATOR = new Parcelable.Creator<CelobjParcel>() {
        public CelobjParcel createFromParcel(Parcel source) {
            return new CelobjParcel(source);
        }

        public CelobjParcel[] newArray(int size) {
            return new CelobjParcel[size];
        }
    };

    private CelobjParcel(Parcel in) {
        n = in.readInt();
        id = in.readString();
        ngc_ic = in.readInt();
        constel = in.readString();
        tipe = in.readString();
        mag = in.readDouble();
        dim = in.readDouble();
        dist = in.readDouble();
        nom = in.readString();
        all = in.readString();
    }
} // FIN  : class CelobjParcel implements Parcelable